unit CDevice;

interface

uses windows, syncobjs;

//-----------------------------------------------------------------------------
//      SCardInfo
// .  FCI_LOCK_INFO  : CountBorrow,
// NumLastLocks, BatteryCondition
//-----------------------------------------------------------------------------
const FCI_TEMIC        = 1;
      FCI_EM_MARINE		 = 2;
      FCI_LIMIT_LOCKS	 = 4;
      FCI_LOCK_INFO		 = 8;
 //-----------------------------------------------------------------------------
//       
//-----------------------------------------------------------------------------
      rf_SUCCESS				    =	0;	  //   
	    rf_INVALID_PARAM		  = 1;	  //  
	    rf_OPEN_NOT_EXIST		  =	-2;	  //   
	    rf_OPEN_ACCESS			  = -3;   //    
	    rf_NOT_USB				    = -4;   //   USB 
	    rf_OPEN_PORT			    = -5;   //    
	    rf_UNKNOWN_DEVICE		  = -6;	  //  
	    rf_DEVICE_NOT_FOUND	  =	-7;   //   
	    rf_ALREADY_OPEN			  =	-8;	  //    (   )

	    rf_EEPROM_ERROR			  =  -9;	//    
	    rf_DATA_ERROR			    =  -10;	//    -  
	    rf_DEVICE_NOT_CONNECT	=  -11;	//    
	    rf_NO_CARD				    =  -12;	//    
	    rf_DLL_NOT_INIT			  =  -14;	//   
	    rf_NO_ANSWER_FOR_CMD	=  -15;	//    
	    rf_DISPLAY_MODE_ERROR	=  -16;	//       
	    rf_UNKNOWN_ERROR		  =  -17;	//  

	    rf_ERROR_LICENSE_HARD	=  -20;	//   
	    rf_LICENSE_FINISHED		=  -21;	//  
	    rf_LICENSE_NOT_VALID	=  -22; //  

	    rf_CARD_NOT_FOUND		  =  -30;	//   
	    rf_BAD_PASSWORD			  =  -31;	//  
	    rf_ERROR_SAVE_CARD		=  -32;	//   
//-----------------------------------------------------------------------------
type
//-----------------------------------------------------------------------------
//  
//-----------------------------------------------------------------------------
ELicenseStatus = (
      els_no_info		  = 0,	  //  
	    els_ok		    	= $AA,	//  
	    els_none		    = $FE,	//   
	    els_conclude	  = $FD,	//  
	    els_hard_error	= $FC,  //  

      els_delphi      = $12345678 //  Delphi  
);
//-----------------------------------------------------------------------------
//    
//-----------------------------------------------------------------------------
ECardType = (
	    ect_none		     =   0,			//    
	    ect_clean_temic	 = $10,		  //   (  )
	    ect_temic		     = $20,		  //   ( )
	    ect_bad_password = $30,		  // " " (  )
	    esi_em_marine	   = $40,		  // Em-Marine ( 21  2012)

	    //   
	    ect_EEPROM_error = $80,		  //   
	    ect_data_error	 = $81,		  //    -  
	    ect_unknow		   = $F0,		  //    

      ect_delphi       = $12345678 //  Delphi  
);
//-----------------------------------------------------------------------------
//      (ANSI)
//-----------------------------------------------------------------------------
SDeviceInfoA = record
    Port            : array[0..15]  of AnsiChar;  // Com- 
    DeviceName      : array[0..127] of AnsiChar;  //  
    SerialNumber    : DWORD;			                //   
    ModelNumber     : DWORD;			                //  
    FirmwareVersion : DWORD;		                  //  Firmware
    LicenseStatus   : ELicenseStatus;			        //    
    LicenseYear     : DWORD;			                // 
    LicenseMonth    : DWORD;			                // 
    LicenseDay      : DWORD;				              //   
    CountCard       : DWORD;				              // - ,  
                                                  // -  
end;
//-----------------------------------------------------------------------------
//      (UNICODE)
//-----------------------------------------------------------------------------
 SDeviceInfoW = record
    Port            : array[0..15]  of WideChar;  // Com- 
    DeviceName      : array[0..127] of WideChar;  //  
    SerialNumber    : DWORD;			                //   
    ModelNumber     : DWORD;			                //  
    FirmwareVersion : DWORD;		                  //  Firmware
    LicenseStatus   : ELicenseStatus;			        //      (4 )
    LicenseYear     : DWORD;			                // 
    LicenseMonth    : DWORD;			                // 
    LicenseDay      : DWORD;				              //   
    CountCard       : DWORD;				              // - ,  
                                                  // -  
end;
//----------------------------------------------------------------------------------------------------
//    
//----------------------------------------------------------------------------------------------------
SCardInfo = record
    Flags       : DWORD;				       //     
    CardType    : ECardType;  	       //    (4 )

    TemicCode   : array[0..7] of BYTE; //  Temic
    EmMarineCode: array[0..7] of BYTE; //  Em-Marine.   5 
                                       // + 3  -   
    LimitLocks  : DWORD;		   	//  - , 
                                //     (0..15)

    //    FCI_LOCK_INFO,     

    CountBorrow : DWORD;		    // -  
    NumLastLocks: DWORD;		    //    
    BatteryCondition : BOOL;	  //  : TRUE - ,
                                // FALSE -  
end;
//-----------------------------------------------------------------------------
//    dll   
//-----------------------------------------------------------------------------
TDevice = object

  m_hDevice   : HMODULE;

  //       ,  
  _Init : function : DWORD; stdcall; // DLL_PROCESS_ATTACH   

  _OpenDeviceA: function(port : PAnsiChar): DWORD; stdcall;
  _OpenDeviceW: function(port : PWideChar): DWORD; stdcall;

  _SearchDevice: function : DWORD; stdcall;
  _CloseDevice : function : DWORD; stdcall;

  _IsDeviceOpen: function : BOOL;  stdcall;

  // 
  _SetIndicationMode : function (mode: DWORD): DWORD; stdcall;

  _SetDisplayRed  : function (fRed   : BOOL): DWORD; stdcall;
  _SetDisplayGreen: function (fGreen : BOOL): DWORD; stdcall;
  _SetDisplay     : function (fRed : BOOL; fGreen : BOOL): DWORD; stdcall;

  _SetBeep        : function (dwDuration : DWORD): DWORD; stdcall;

  //   
  _GetDeviceInfoA : function (var DevInfo : SDeviceInfoA): DWORD; stdcall;
  _GetDeviceInfoW : function (var DevInfo : SDeviceInfoW): DWORD; stdcall;

  //     
  _ReadCard       : function (var CardInfo : SCardInfo): DWORD; stdcall;
  _ClearCard      : function : DWORD; stdcall;
  _InitCard       : function (EmMarineCode : array of BYTE): DWORD; stdcall;
  _WriteCard      : function (LimitLocks : DWORD): DWORD; stdcall;

  //   
  _GetMaskEvent   : function (var MaskEvent: DWORD): DWORD; stdcall;

  _SetModeSelectMsg   : function(hWnd: HWND; Msg: UINT; Delay: DWORD): DWORD; stdcall;
  _SetModeSelectEvent : function(hEvent: THANDLE; Delay:DWORD): DWORD; stdcall;

public
    Constructor Create;   // TDevice();
    Destructor  Destroy;  // ~TDevice();

    //  
    function LoadDll(var str : string): boolean;

    //   
    function Init : bool;

    function OpenDevice(port : string): DWORD;
    function SearchDevice: DWORD;
    function CloseDevice : DWORD;
    function IsDeviceOpen: bool;
{
    // 
    function SetIndicationMode(mode: DWORD): DWORD;
    function SetDisplayRed(fRed : BOOL): DWORD;
    function SetDisplayGreen(fGreen : BOOL): DWORD;
    function SetDisplay(fRed : BOOL; fGreen : BOOL): DWORD;
    function SetBeep(dwDuration : DWORD): DWORD;
 }
    //   
    function GetDeviceInfoA(var DevInfo : SDeviceInfoA): DWORD;
    function GetDeviceInfoW(var DevInfo : SDeviceInfoW): DWORD;

    //     
    function ReadCard(var CardInfo : SCardInfo): DWORD;
{
    function ClearCard : DWORD;
    function InitCard(EmMarineCode : array of BYTE): DWORD;
    function WriteCard(LimitLocks : DWORD): DWORD;

    function GetMaskEvent(var MaskEvent: DWORD): DWORD;

    function SetModeSelectEvent(hEvent: THANDLE; Delay:DWORD): DWORD;
 }
    function SetModeSelectMsg(hWnd: HWND; Msg: UINT; Delay: DWORD): DWORD;

private
//  , , ;
public
//  , , ;
protected
//  , , ;


end;

implementation
//-----------------------------------------------------------------------------
//  TDevice::TDevice
//-----------------------------------------------------------------------------
constructor TDevice.Create;
begin
    m_hDevice := 0;
end;
//-----------------------------------------------------------------------------
//  TDevice::~TDevice
//-----------------------------------------------------------------------------
destructor TDevice.Destroy;
begin
     if(m_hDevice <> 0) then
       FreeLibrary(m_hDevice);
end;
//-----------------------------------------------------------------------------
//   dll
//-----------------------------------------------------------------------------
function TDevice.LoadDll(var str : string): boolean;
begin
  Result := false;

  m_hDevice := LoadLibrary('rf1996.dll');

  if(m_hDevice = 0) then
    str := '  dll'
  else
    begin
     @_Init := GetProcAddress(m_hDevice, 'Init');

     @_OpenDeviceA       := GetProcAddress(m_hDevice, 'OpenDeviceA');
     @_OpenDeviceW       := GetProcAddress(m_hDevice, 'OpenDeviceW');
     @_SearchDevice      := GetProcAddress(m_hDevice, 'SearchDevice');
     @_CloseDevice       := GetProcAddress(m_hDevice, 'CloseDevice');
     @_IsDeviceOpen      := GetProcAddress(m_hDevice, 'IsDeviceOpen');

     @_SetIndicationMode := GetProcAddress(m_hDevice, 'SetIndicationMode');
     @_SetDisplayRed     := GetProcAddress(m_hDevice, 'SetDisplayRed');
     @_SetDisplayGreen   := GetProcAddress(m_hDevice, 'SetDisplayGreen');
     @_SetDisplay        := GetProcAddress(m_hDevice, 'SetDisplay');
     @_SetBeep           := GetProcAddress(m_hDevice, 'SetBeep');
     @_GetDeviceInfoA    := GetProcAddress(m_hDevice, 'GetDeviceInfoA');
     @_GetDeviceInfoW    := GetProcAddress(m_hDevice, 'GetDeviceInfoW');
     @_ReadCard          := GetProcAddress(m_hDevice, 'ReadCard');
     @_ClearCard         := GetProcAddress(m_hDevice, 'ClearCard');
     @_InitCard          := GetProcAddress(m_hDevice, 'InitCard');
     @_WriteCard         := GetProcAddress(m_hDevice, 'WriteCard');
     @_GetMaskEvent      := GetProcAddress(m_hDevice, 'GetMaskEvent');
     @_SetModeSelectMsg  := GetProcAddress(m_hDevice, 'SetModeSelectMsg');
     @_SetModeSelectEvent:= GetProcAddress(m_hDevice, 'SetModeSelectEvent');

    if(
        (@_Init  <> NIL) AND

        (@_OpenDeviceA        <> NIL) AND
        (@_OpenDeviceW        <> NIL) AND
        (@_SearchDevice       <> NIL) AND
        (@_CloseDevice        <> NIL) AND
        (@_IsDeviceOpen       <> NIL) AND

        (@_SetIndicationMode  <> NIL) AND
        (@_SetDisplayRed      <> NIL) AND
        (@_SetDisplayGreen    <> NIL) AND
        (@_SetDisplay         <> NIL) AND
        (@_SetBeep            <> NIL) AND

        (@_GetDeviceInfoA     <> NIL) AND
        (@_GetDeviceInfoW     <> NIL) AND

        (@_ReadCard           <> NIL) AND
        (@_ClearCard          <> NIL) AND
        (@_InitCard           <> NIL) AND
        (@_WriteCard          <> NIL) AND

        (@_GetMaskEvent       <> NIL) AND
        (@_SetModeSelectMsg   <> NIL) AND
        (@_SetModeSelectEvent <> NIL)
    )then
      Result := Init  //  
    else
      str := '     dll'
    end;
end;
//-----------------------------------------------------------------------------
//   
//-----------------------------------------------------------------------------
function TDevice.Init : bool;
begin
  if(_Init = 0) then
    Result := true
  else
    Result := false;
end;
//-----------------------------------------------------------------------------
//       COM-.
//     Delphi  2009    _OpenDeviceA
//-----------------------------------------------------------------------------
function TDevice.OpenDevice(port : string)  : DWORD;
begin
  Result := _OpenDeviceW(PCHAR(port));
end;
//-----------------------------------------------------------------------------
//     COM-,   .
//      Thread
//-----------------------------------------------------------------------------
function TDevice.SearchDevice: DWORD;
begin
  Result := _SearchDevice;
end;
//-----------------------------------------------------------------------------
//   
//-----------------------------------------------------------------------------
function TDevice.CloseDevice:  DWORD;
begin
  Result := _CloseDevice;
end;
//-----------------------------------------------------------------------------
//  ,     
//-----------------------------------------------------------------------------
function TDevice.IsDeviceOpen: BOOL;
begin
  Result := _IsDeviceOpen;
end;
//----------------------------------------------------------------------------
//      
//----------------------------------------------------------------------------
function TDevice.GetDeviceInfoA(var DevInfo : SDeviceInfoA): DWORD;
begin
	Result := _GetDeviceInfoA(DevInfo);
end;
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
function TDevice.GetDeviceInfoW(var DevInfo : SDeviceInfoW) : DWORD;
begin
	Result := _GetDeviceInfoW(DevInfo);
end;
//-----------------------------------------------------------------------------
//  
//-----------------------------------------------------------------------------
function TDevice.ReadCard(var CardInfo : SCardInfo): DWORD;
begin
   Result := _ReadCard(CardInfo);
end;
//-----------------------------------------------------------------------------
//       
//-----------------------------------------------------------------------------
function TDevice.SetModeSelectMsg(hWnd: HWND; Msg: UINT; Delay: DWORD): DWORD;
begin
  Result := _SetModeSelectMsg(hWnd, Msg, Delay);
end;
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
end.
