unit DemoRF1996;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus, About, CDevice, Vcl.StdCtrls,
  Vcl.ExtCtrls, Vcl.ComCtrls;

const
  WM_DLL_EVENT = WM_USER + 1;

type
   PSCardInfo = ^SCardInfo;

  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    Exit: TMenuItem;

    About: TMenuItem;
    btnConnect: TButton;
    gbDeviceInfo: TGroupBox;
    lvDeviceInfo: TListView;
    gbCardInfo: TGroupBox;
    btnRequest: TButton;
    lvCardInfo: TListView;
    gbAsync: TGroupBox;
    cbAsync: TCheckBox;
    lbDelayReq: TLabel;
    edPeriod: TEdit;
    udPeriod: TUpDown;
    lbMs: TLabel;
    rgEventInfo: TRadioGroup;
    lvListEvent: TListView;
    gbIndication: TGroupBox;
    rdManual: TRadioButton;
    rdAuto: TRadioButton;
    gbConnectParam: TGroupBox;
    edPort: TEdit;
    rbPort: TRadioButton;
    rbScan: TRadioButton;
    cbRed: TCheckBox;
    cbGreen: TCheckBox;
    btnSound: TButton;
    edSoundDuration: TEdit;
    udSoundDuration: TUpDown;
    lbOnSound: TLabel;
    lnOnMs: TLabel;

    procedure ExitClick(Sender: TObject);
    procedure AboutClick(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure OnCreate(Sender: TObject);
    procedure btnRequestClick(Sender: TObject);
    procedure btnSoundClick(Sender: TObject);
    procedure rbPortClick(Sender: TObject);
    procedure rbScanClick(Sender: TObject);
    procedure OnClose(Sender: TObject; var Action: TCloseAction);
    procedure cbAsyncClick(Sender: TObject);
  private
    { Private declarations }
    m_Count : integer;
    m_CaptionButtonConnect : string;

    procedure OnPortEnable(IsEnable : bool);

    procedure AddTextEvent(Event : string);
    procedure AddRetCodeEvent(code : integer);

    procedure  OutDeviceInfo;
    procedure  ClearDeviceInfo;

    procedure  PrintErrorCard(ret : DWORD);
    procedure  PrintCard(CardInfo : SCardInfo);

    procedure SetProgressPos(var Msg: TMessage); message WM_DLL_EVENT;
  public
    { Public declarations }
  end;

 const
  m_Caption : String = 'DemoRF96';
  m_CaptionButtonDisConnect : string = '';

var
  MainForm : TMainForm;
  m_Device : TDevice;

implementation

{$R *.dfm}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
procedure TMainForm.OnPortEnable(IsEnable : bool);
begin
     edPort.Enabled := IsEnable;
end;
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
procedure TMainForm.AboutClick(Sender: TObject);
begin
      AboutForm.ShowModal();
end;
//-----------------------------------------------------------------------------
//         
//-----------------------------------------------------------------------------
procedure TMainForm.AddTextEvent(Event : string);
begin
       lvListEvent.Items.Add;
       lvListEvent.Items[m_Count].Caption := Event;
end;
//-----------------------------------------------------------------------------
//    
//-----------------------------------------------------------------------------
procedure TMainForm.AddRetCodeEvent(code : integer);
var
str : string;
begin
       str := IntToStr(code);
       lvListEvent.Items[m_Count].SubItems.Add(str);
       m_Count := m_Count + 1;
end;
//-----------------------------------------------------------------------------
//       
//-----------------------------------------------------------------------------
procedure  TMainForm.OutDeviceInfo;
Var
  DevInfo : SDeviceInfoW;
  str     : string;
begin
    if(m_Device.GetDeviceInfoW(DevInfo) <> 0)  then
       ClearDeviceInfo
    else
      begin
        // COM-
        lvDeviceInfo.Items[0].SubItems[0] := DevInfo.Port;

        // 
        lvDeviceInfo.Items[1].SubItems[0] := DevInfo.DeviceName;

        //   
        str := IntToStr(DevInfo.SerialNumber);
        lvDeviceInfo.Items[2].SubItems[0] := str;

        // 
        str := IntToStr(DevInfo.ModelNumber);
        lvDeviceInfo.Items[3].SubItems[0] := str;

        // FirmWare
        str := IntToStr(DevInfo.FirmwareVersion);
        lvDeviceInfo.Items[4].SubItems[0] := str;

        //   
        case DevInfo.LicenseStatus of
           els_no_info :    str := ' ';
           els_none:        str := '  ';
           els_conclude:    str := ' ';
           els_hard_error:  str := ' ';
           els_ok:          str := '  ' +
                            IntToStr(DevInfo.LicenseDay) +
                            '.' +
                            IntToStr(DevInfo.LicenseMonth) +
                            '.' +
                            IntToStr(DevInfo.LicenseYear)
                            ;
           else
             str := ' ';
        end;
        lvDeviceInfo.Items[5].SubItems[0] := str;

        // - 
        if(DevInfo.LicenseStatus = els_ok) then
          str := IntToStr(DevInfo.CountCard)
        else
          str := '';

        lvDeviceInfo.Items[6].SubItems[0] := str;
    end;
end;
//-----------------------------------------------------------------------------
//       
//-----------------------------------------------------------------------------
procedure  TMainForm.ClearDeviceInfo;
Var
   i : integer;
begin
    for I := 0 to 2 do
    begin
        if(lvDeviceInfo.Items[i].SubItems.Count < 1) then
          lvDeviceInfo.Items[i].SubItems.Add('')
        else
          lvDeviceInfo.Items[i].SubItems[0] := '';
    end;
end;
//-----------------------------------------------------------------------------
//    -  
//-----------------------------------------------------------------------------
procedure TMainForm.btnConnectClick(Sender: TObject);
Var
   ret : DWORD;
begin
    if(m_device._IsDeviceOpen) then
    begin
//       
      AddTextEvent('CloseDevice');

      ret := m_Device.CloseDevice;

      AddRetCodeEvent(ret);

       if(ret = 0) then //  
       begin
          btnConnect.Caption := m_CaptionButtonConnect; //   
          ClearDeviceInfo;
       end;
    end
    else
 //      
      begin
         if(rbPort.Checked) then
           begin
//           
             AddTextEvent('OpenDevice');

             ret := m_Device.OpenDevice(edPort.Text);
           end
         else
           begin
//            
             AddTextEvent('SearchDevice');

             ret := m_device.SearchDevice;
           end;

         AddRetCodeEvent(ret);  //   

         if(ret = 0) then       //  
         begin
            btnConnect.Caption := m_CaptionButtonDisConnect; //
            btnRequest.Enabled := true;
            cbAsync.Enabled    := true;
            OutDeviceInfo;  //    
         end;

    end;
end;
//-----------------------------------------------------------------------------
//         
//-----------------------------------------------------------------------------
procedure TMainForm.PrintErrorCard(ret : DWORD);
var
   str : string;
   i   : integer;
begin
    for i := 0 to 2 do
      lvCardInfo.Items[i].SubItems[0] := '';

    i := ret;
    case i of
      rf_NO_CARD:       str := '   ';
      rf_EEPROM_ERROR:  str := '  ';
      rf_DATA_ERROR:    str := '  ';
      else
        str := ' ';
    end;
    lvCardInfo.Items[0].SubItems[0] := str;
end;
//-----------------------------------------------------------------------------
//         
//-----------------------------------------------------------------------------
procedure TMainForm.PrintCard(CardInfo : SCardInfo);
var
   str : string;
begin
		//  ,   -   

		case CardInfo.CardType of
		ect_clean_temic:	str := ' ';
		ect_temic:			  str := '  ';
		ect_bad_password:	str := ' ';
		esi_em_marine:		str := 'Em-Marine';
		else
     		str := ' ';
		end;

		//
		lvCardInfo.Items[0].SubItems[0] := str;

		//  
    if((CardInfo.Flags AND FCI_TEMIC) <> 0) then
      str := IntToHex(CardInfo.TemicCode[0], 2) + ' ' +
             IntToHex(CardInfo.TemicCode[1], 2) + ' ' +
             IntToHex(CardInfo.TemicCode[2], 2) + ' ' +
             IntToHex(CardInfo.TemicCode[3], 2) + ' ' +
             IntToHex(CardInfo.TemicCode[4], 2) + ' ' +
             IntToHex(CardInfo.TemicCode[5], 2) + ' ' +
             IntToHex(CardInfo.TemicCode[6], 2) + ' ' +
             IntToHex(CardInfo.TemicCode[7], 2)
   else
    str := '';

	  lvCardInfo.Items[1].SubItems[0] := str;

    //  Em-Marine
    if((CardInfo.Flags AND FCI_EM_MARINE) <> 0) then
    begin
         str := '[' +
                IntToHex(CardInfo.EmMarineCode[4] * 256 +
                           CardInfo.EmMarineCode[3], 4) +
                ']  ';

         str := str + IntToStr(CardInfo.EmMarineCode[2]) + ', ';

         str := str + IntToStr(CardInfo.EmMarineCode[1] * 256 +
                           CardInfo.EmMarineCode[0])
         ;
    end
		  else
			   str := '';

		lvCardInfo.Items[2].SubItems[0] := str;

		//  
    if((CardInfo.Flags AND FCI_LIMIT_LOCKS) <> 0) then
			str := IntToStr(CardInfo.LimitLocks)
		else
			str := '';

		lvCardInfo.Items[3].SubItems[0] := str;

		// - 
    if((CardInfo.Flags AND FCI_LOCK_INFO) <> 0) then
			str := IntToStr(CardInfo.CountBorrow)
		else
			str := '';

		lvCardInfo.Items[4].SubItems[0] := str;

 		//  
    if((CardInfo.Flags AND FCI_LOCK_INFO) <> 0) then
			str := IntToStr(CardInfo.NumLastLocks)
		else
			str := '';

	 lvCardInfo.Items[5].SubItems[0] := str;

		//  
		str := '';
    if((CardInfo.Flags AND FCI_LOCK_INFO) <> 0) then
		begin
			if(CardInfo.BatteryCondition)  then
				str := ''
			else
        str := '';
		end;

    lvCardInfo.Items[5].SubItems[0] := str;

end;
//-----------------------------------------------------------------------------
//      ""
//-----------------------------------------------------------------------------
procedure TMainForm.btnRequestClick(Sender: TObject);
var
   CardInfo : SCardInfo;
   ret      : DWORD;
begin
      ret := m_Device.ReadCard(CardInfo);

      if(ret <> 0) then
         PrintErrorCard(ret)
      else
         PrintCard(CardInfo);	//   

end;
//-----------------------------------------------------------------------------
//   
//-----------------------------------------------------------------------------
procedure TMainForm.SetProgressPos(var Msg: TMessage);
var
  CardInfo : ^SCardInfo;
  ret      : DWORD;
begin
   ret := msg.WParam;  //  
//   CardInfo := reinterpret_cast<SCardInfo*>(msg.LParam);  //  

   //    ,   DEplhi  
     Application.MessageBox('   ', PChar(m_Caption), MB_OK);


end;
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
procedure TMainForm.btnSoundClick(Sender: TObject);
begin
    Application.MessageBox('', PChar(m_Caption), MB_OK);
end;
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
procedure TMainForm.cbAsyncClick(Sender: TObject);
begin
    if(cbAsync.Checked) then
      begin
        m_Device.SetModeSelectMsg(Handle, WM_DLL_EVENT, 500);
      end
    else
      begin
        m_Device.SetModeSelectMsg(NULL, 0, 0);
      end;
end;
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
procedure TMainForm.ExitClick(Sender: TObject);
begin
       MainForm.Close();
end;
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
procedure TMainForm.OnClose(Sender: TObject; var Action: TCloseAction);
Var
   ret : DWORD;
begin
    AddTextEvent('CloseDevice');

    ret := m_Device.CloseDevice;

    AddRetCodeEvent(ret);
end;
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
procedure TMainForm.OnCreate(Sender: TObject);
Var
   str : string;
begin
    rbPort.Checked        := true;                //   
    m_Count               := 0;                   //
    m_CaptionButtonConnect:= btnConnect.Caption;  //    

    if(NOT m_Device.LoadDll(str))   then
      Application.MessageBox(PChar(str), PChar(m_Caption), MB_OK OR MB_ICONERROR);


end;
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
procedure TMainForm.rbPortClick(Sender: TObject);
begin
    OnPortEnable(true);
end;
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
procedure TMainForm.rbScanClick(Sender: TObject);
begin
     OnPortEnable(false);
end;
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
end.
