﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Windows;
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
namespace DemoRF1996
{
    public partial class MainForm : Form
    {
        private About formAbout = new About();          // FixME: Для отображения номера версии библиотеки (пока не работает)
        private Scanning formScanning = new Scanning(); // Диалог сканирования адаптера RF-1996 ( проблемы со стабильной работой )

        private NRF1996.CRF1996 MyDevice = new NRF1996.CRF1996();   // Как я люблю C#

        private NRF1996.CRF1996.SDeviceInfoW data = new NRF1996.CRF1996.SDeviceInfoW();  // Информация об адаптере RF-1996
        private NRF1996.CRF1996.SCardInfo CardInfo = new NRF1996.CRF1996.SCardInfo();    // Информация об карте на адаптере RF-1996

        private const string m_CaptionButtonDisConnect = "Отключится";
        private string m_CaptionButtonConnect;

        private const Int32 WM_USER = 0x0400;
        private const Int32 WM_DLL_EVENT = WM_USER + 1;
        /////////////////////////////////////////////////////////////////////////////
        /// <summary>
        /// Конструктор
        /// </summary>
        /////////////////////////////////////////////////////////////////////////////
        public MainForm()
        {
            InitializeComponent();
            AddOwnedForm( formAbout );
            AddOwnedForm( formScanning );
        }
        /////////////////////////////////////////////////////////////////////////////
        /// <summary>
        /// Пункт меню "Выход"
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /////////////////////////////////////////////////////////////////////////////
        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }
        /////////////////////////////////////////////////////////////////////////////
        /// <summary>
        /// Пункт меню "О программе"
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /////////////////////////////////////////////////////////////////////////////
        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            formAbout.Owner = this;
            formAbout.Show();
        }
        /////////////////////////////////////////////////////////////////////////////
        //
        /////////////////////////////////////////////////////////////////////////////
        private void rbScan_CheckedChanged(object sender, EventArgs e)
        {
            tbCOM.Enabled = false;
        }

        private void rbPort_CheckedChanged(object sender, EventArgs e)
        {
            tbCOM.Enabled = true;
        }
        /////////////////////////////////////////////////////////////////////////////
        /// <summary>
        /// Добавить строку в Event
        /// </summary>
        /// 
        /////////////////////////////////////////////////////////////////////////////
        public void AddTextEvent(string str)
        {
            lvEvent.Items.Add( str );
        }
        /////////////////////////////////////////////////////////////////////////////
        /// <summary>
        /// Добавить код завершения функции
        /// </summary>
        /// 
        /////////////////////////////////////////////////////////////////////////////
        void AddCodeEvent(Int32 Code)
        {
            int nCount = lvEvent.Items.Count;

            ListViewItem item = lvEvent.Items[ nCount - 1];

            item.SubItems.Add( Code.ToString( ) );
        }
        /////////////////////////////////////////////////////////////////////////////
        /// <summary>
        /// Блокировка-разблокировка элементов управления
        /// </summary>
        /////////////////////////////////////////////////////////////////////////////
        private void EnableControls(bool fPortOpen)
        {
            bool Flag;

            btnRequest.Enabled = fPortOpen;
            cbAsync.Enabled = fPortOpen;
            rbSoundAuto.Enabled = fPortOpen;
            rbSoundManual.Enabled = fPortOpen;

            nudMaxLocks.Enabled = fPortOpen;

            btnGiveOut.Enabled = fPortOpen;
            btnClearCard.Enabled = fPortOpen;

            tbSquare.Enabled = fPortOpen;
            nudHi.Enabled = fPortOpen;
            nudLow.Enabled = fPortOpen;
            btnSave.Enabled = fPortOpen;

            // Контролы асинхронного режима
            bool fAsyncMode;

            if( cbAsync.Checked )
                fAsyncMode = true;
            else
                fAsyncMode = false;

            if (fPortOpen && fAsyncMode)
                Flag = true;
            else
                Flag = false;

            lblPeriod.Enabled = Flag;
            nudPeriod.Enabled = Flag;
            lblMS.Enabled     = Flag;
            gbEvent.Enabled   = Flag;

            rbCommand.Enabled = Flag;
            rbSetEvent.Enabled= Flag;

            // Управление светодиодами
            if ( fPortOpen && ( rbSoundManual.Checked ) )
                Flag = true;
            else
                Flag = false;

            cbRed.Enabled   = Flag;
            cbGreen.Enabled = Flag;
            lblOnSound.Enabled = Flag;
            nudSoundDuration.Enabled = Flag;
            lblMsSound.Enabled = Flag;
            btnSound.Enabled   = Flag;
        }

        /////////////////////////////////////////////////////////////////////////////
        /// <summary>
        /// Вывести информацию об устройстве
        /// </summary>
        /////////////////////////////////////////////////////////////////////////////
        private void PrintDeviceInfo()
        {
            int     nCount = lvListDevice.Items.Count;
            string  str = " ";
            Int32   ret;

            // Запрос информации об адаптере RF-1996
            AddTextEvent("GetDeviceInfoW");
            ret = NRF1996.CRF1996.GetDeviceInfoW( ref data );
            AddCodeEvent(ret);

            // Вывод параметров RF-1996

            lvListDevice.Items[0].SubItems[1].Text = data.Port;                         // Com-порт устройства
            lvListDevice.Items[1].SubItems[1].Text = data.DeviceName;                   // Наименование устройства
            lvListDevice.Items[2].SubItems[1].Text = data.SerialNumber.ToString();      // Серийный номер устройства
            lvListDevice.Items[3].SubItems[1].Text = data.ModelNumber.ToString();       // Номер модели
            lvListDevice.Items[4].SubItems[1].Text = data.FirmwareVersion.ToString();   // Версия Firmware

            // Информация о лицензии
            switch (data.LicenseStatus)
            {
                case NRF1996.CRF1996.ELicenseStatus.els_no_info:    str = "Нет информации"; break;
                case NRF1996.CRF1996.ELicenseStatus.els_none:       str = "Лицензия не действительная"; break;
                case NRF1996.CRF1996.ELicenseStatus.els_conclude:   str = "Лицензия закончилась"; break;
                case NRF1996.CRF1996.ELicenseStatus.els_hard_error: str = "Аппаратные ошибки"; break;

                case NRF1996.CRF1996.ELicenseStatus.els_ok:
                    str = String.Format("Лицензия от {0:d2}.{1:d2}.{2:d4}", data.LicenseDay, data.LicenseMonth, data.LicenseYear);
                    break;

                default:
                    str = "Неизвестная ошибка";
                    break;
            }
            lvListDevice.Items[5].SubItems[1].Text = str;

            // Если есть информация о лицензии
            if (NRF1996.CRF1996.ELicenseStatus.els_ok == data.LicenseStatus)
                str = data.CountCard.ToString();// Кол-во карт, доступных для стирания-записи по лицензии
            else
                str = "";     // Нет информации
            lvListDevice.Items[6].SubItems[1].Text = str;     // Нет информации
        }
        /////////////////////////////////////////////////////////////////////////////
        /// <summary>
        /// Очистить информацию об устройстве
        /// </summary>
        /////////////////////////////////////////////////////////////////////////////
        private void ClearDeviceInfo()
        {
            lvListDevice.Items[0].SubItems[1].Text = "";    // Com-порт устройства
            lvListDevice.Items[1].SubItems[1].Text = "";    // Наименование устройства
            lvListDevice.Items[2].SubItems[1].Text = "";    // Серийный номер устройства
            lvListDevice.Items[3].SubItems[1].Text = "";    // Номер модели
            lvListDevice.Items[4].SubItems[1].Text = "";    // Версия Firmware
            lvListDevice.Items[5].SubItems[1].Text = "";    // Информация о лицензии
            lvListDevice.Items[6].SubItems[1].Text = "";    // Если есть информация о лицензии
        }
        /////////////////////////////////////////////////////////////////////////////
        /// <summary>
        /// Нажатие кнопки Connect
        /// </summary>
        /////////////////////////////////////////////////////////////////////////////
        private void btnConnect_Click(object sender, EventArgs e)
        {
            Int32 ret = 0;

            if (NRF1996.CRF1996.IsDeviceOpen() != 0)
            {
                AddTextEvent("CloseDevice");
                ret = NRF1996.CRF1996.CloseDevice();
                AddCodeEvent(ret);

                // Подправляем заголовок кнопки
                btnConnect.Text = m_CaptionButtonConnect;

                // Разблокируем кнопки управление
                EnableControls(false);

                // Очищаем информацию об устройстве
                ClearDeviceInfo();
            }
            else
            {
                if (rbPort.Checked)
                {   // Открываем устройство с заданным портом
                    AddTextEvent("OpenDeviceW");
                    ret = NRF1996.CRF1996.OpenDeviceW(tbCOM.Text);
                    AddCodeEvent(ret);
                }
                else
                {   // Сканирование портов
                    formScanning.Owner = this;
                    formScanning.ShowDialog();
                }

                // Если устройство открыто
                if (NRF1996.CRF1996.IsDeviceOpen() != 0)
                {
                    PrintDeviceInfo();      // Выводим информацию об устройстве	

                    // Подправляем заголовок кнопки
                    btnConnect.Text = m_CaptionButtonDisConnect;

                    // Разблокируем кнопки управление
                    EnableControls(true);
                }
            }
        }
        /////////////////////////////////////////////////////////////////////////////
        //      Отобразить информацию о карте на экране ( карта прочитана)
        /////////////////////////////////////////////////////////////////////////////
        void PrintCard(ref NRF1996.CRF1996.SCardInfo  CardInfo)
        {
            string str = " ";
    
            // Карта прочитана, нет ошибок - выводим тип карты
            switch (CardInfo.CardType)
            {
                case NRF1996.CRF1996.ECardType.ect_clean_temic: str = "Чистый Темик"; break;
                case NRF1996.CRF1996.ECardType.ect_temic:       str = "Темик с паролем"; break;
                case NRF1996.CRF1996.ECardType.ect_bad_password:str = "Неверный пароль"; break;
                case NRF1996.CRF1996.ECardType.esi_em_marine:   str = "Em-Marine"; break;
                default:                                        str = "Неизвестное значение"; break;
            }
    
            CardInfo.GetCardType(ref str);
            lvCardInfo.Items[0].SubItems[1].Text = str;
    
            // Код Темик
            CardInfo.GetTemicCode(ref str);
            lvCardInfo.Items[1].SubItems[1].Text = str;
    
            // Код Em-Marine
            CardInfo.GetEmMarineCode(ref str);
            lvCardInfo.Items[2].SubItems[1].Text = str;
    
            // Лимит шкафчиков
            CardInfo.GetLimitBoxes(ref str);
            lvCardInfo.Items[3].SubItems[1].Text = str;
    
            // Кол-во занятых
            CardInfo.GetCountBorrow(ref str);
            lvCardInfo.Items[4].SubItems[1].Text = str;
    
            // Последний занятый
            CardInfo.GetNumLastLocks(ref str);
            lvCardInfo.Items[5].SubItems[1].Text = str;
    
            // Состояние батареи
            CardInfo.GetBatteryCondition(ref str);
            lvCardInfo.Items[6].SubItems[1].Text = str;
        }
    
        /////////////////////////////////////////////////////////////////////////////
        //        Ошибка чтения карты на адаптере
        /////////////////////////////////////////////////////////////////////////////
        private void PrintErrorCard( Int32 ret )
        {
            string str;
    
            switch ((NRF1996.CRF1996.EErrorCode)ret)
            {
                case NRF1996.CRF1996.EErrorCode.rf_NO_CARD:      str = "Нет карты на адаптере"; break;
                case NRF1996.CRF1996.EErrorCode.rf_EEPROM_ERROR: str = "Не читается ключ";      break;
                case NRF1996.CRF1996.EErrorCode.rf_DATA_ERROR:   str = "Не прочитать данные";   break;
                default:                                         str = "Неизвестная ошибка";    break;
            }
    
            lvCardInfo.Items[0].SubItems[1].Text = str;
            lvCardInfo.Items[1].SubItems[1].Text = "";
            lvCardInfo.Items[2].SubItems[1].Text = "";
            lvCardInfo.Items[3].SubItems[1].Text = "";
            lvCardInfo.Items[4].SubItems[1].Text = "";
            lvCardInfo.Items[5].SubItems[1].Text = "";
            lvCardInfo.Items[6].SubItems[1].Text = "";
        }
        /////////////////////////////////////////////////////////////////////////////
        //
        /////////////////////////////////////////////////////////////////////////////
        private void OnReadCard()
        {
            Int32 ret;

            AddTextEvent(("ReadCard"));
            ret = NRF1996.CRF1996.ReadCard(ref CardInfo);
            AddCodeEvent(ret);

            if (ret == 0)
                PrintCard(ref CardInfo);    // Выводим состояние карты
            else
                PrintErrorCard(ret);
        }
        /////////////////////////////////////////////////////////////////////////////
        //          Нажатие кнопки "Опросить"
        /////////////////////////////////////////////////////////////////////////////
        private void btnRequest_Click(object sender, EventArgs e)
        {
            OnReadCard();
        }
        /////////////////////////////////////////////////////////////////////////////
        //          Нажатие кнопки "Записать"
        /////////////////////////////////////////////////////////////////////////////
        private void btnSave_Click(object sender, EventArgs e)
        {
            Int32 ret;
            byte[]  EmMarineCode = new byte[5];

            EmMarineCode[0] = (byte)(nudLow.Value % 256);
            EmMarineCode[1] = (byte)(nudLow.Value / 256);

            EmMarineCode[2] = (byte)(nudHi.Value);

            EmMarineCode[3] = Convert.ToByte(tbSquare.Text.Substring( 2, 2), 16);
            EmMarineCode[4] = Convert.ToByte(tbSquare.Text.Substring(0, 2), 16);

            AddTextEvent( "InitCard" );
            ret = NRF1996.CRF1996.InitCard(EmMarineCode);
            AddCodeEvent(ret);
        }
        /////////////////////////////////////////////////////////////////////////////
        //          Нажатие кнопки "Выписать"
        /////////////////////////////////////////////////////////////////////////////
        private void btnGiveOut_Click(object sender, EventArgs e)
        {
            Int32 ret;
            Int32 LimitLocks = 0;

            LimitLocks = Convert.ToInt32( nudMaxLocks.Value );

            AddTextEvent( "WriteCard" );
            ret = NRF1996.CRF1996.WriteCard( LimitLocks );
            AddCodeEvent( ret );
        }
        /////////////////////////////////////////////////////////////////////////////
        // Стереть пароль с карты
        /////////////////////////////////////////////////////////////////////////////
        private void btnClearCard_Click(object sender, EventArgs e)
        {
            Int32 ret;

            AddTextEvent( "ClearCard" );
            ret = NRF1996.CRF1996.ClearCard();
            AddCodeEvent( ret );
        }
        /////////////////////////////////////////////////////////////////////////////
        //
        /////////////////////////////////////////////////////////////////////////////
        /// <summary>
        /// Загрузка формы
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void MainForm_Load(object sender, EventArgs e)
        {
            EnableControls( false );    // Блокируем контролы управление индикацией
    
            // Заголовки кнопок
            m_CaptionButtonConnect = btnConnect.Text;
           
            // Инициализируем библиотеку
            if( NRF1996.CRF1996.Init() != 0 )    //
                MessageBox.Show("Ошибка инициализации RF1996.dll!");
        }
        /////////////////////////////////////////////////////////////////////////////
        // Автоматическое управление светодиодами
        /////////////////////////////////////////////////////////////////////////////
        private void rbSoundAuto_CheckedChanged(object sender, EventArgs e)
        {
            Int32 ret;
    
            if (rbSoundAuto.Checked)
            {
                EnableControls(false);
    
                // Включаем режим работы индикации
                AddTextEvent("SetIndicationMode");
                ret = NRF1996.CRF1996.SetIndicationMode( 0 );    // Режим работы индикации
                AddCodeEvent(ret);
            }
        }
        /////////////////////////////////////////////////////////////////////////////
        // Ручное управление диодоми
        /////////////////////////////////////////////////////////////////////////////
        private void rbSoundManual_CheckedChanged(object sender, EventArgs e)
        {
            Int32 ret;
    
            if (rbSoundManual.Checked)
            {
                EnableControls(true);
    
                // Включаем режим работы индикации
                AddTextEvent("SetIndicationMode");
                ret = NRF1996.CRF1996.SetIndicationMode( 1 );    // Режим работы индикации
                AddCodeEvent(ret);
    
                // Состояние светодиодов
                Int32 m_Red, m_Green;
    
                if( cbRed.Checked )
                    m_Red = 1;
                else
                    m_Red = 0;
    
                if( cbGreen.Checked )
                    m_Green = 1;
                else
                    m_Green = 0;
    
                AddTextEvent( "SetDisplay" );
                ret = NRF1996.CRF1996.SetDisplay( m_Red, m_Green );
                AddCodeEvent(ret);
            }
        }
        /////////////////////////////////////////////////////////////////////////////
        // Включить-выключить красный светодиод
        /////////////////////////////////////////////////////////////////////////////
        private void cbRed_CheckedChanged(object sender, EventArgs e)
        {
            Int32 ret;
            Int32 Flag;
    
            if( cbRed.Checked )
            {
                Flag = 1;
            }
            else
            {
                Flag = 0;
            }
    
            AddTextEvent( "SetDisplayRed" );
            ret = NRF1996.CRF1996.SetDisplayRed( Flag );
            AddCodeEvent(ret);
        }
        /////////////////////////////////////////////////////////////////////////////
        // Включить-выключить зеленый светодиод
        /////////////////////////////////////////////////////////////////////////////
        private void cbGreen_CheckedChanged(object sender, EventArgs e)
        {
            Int32 ret;
            Int32 Flag;
    
            if( cbGreen.Checked )
            {
                Flag = 1;
            }
            else
            {
                Flag = 0;
            }
    
            AddTextEvent( "SetDisplayGreen" );
            ret = NRF1996.CRF1996.SetDisplayGreen( Flag );
            AddCodeEvent(ret);
        }
        /////////////////////////////////////////////////////////////////////////////
        // Небольшая оптимизация
        /////////////////////////////////////////////////////////////////////////////
        [System.Security.Permissions.PermissionSet(System.Security.Permissions.SecurityAction.Demand, Name = "FullTrust")]
        protected override void WndProc(ref Message m)
        {
            // Слушаем сообщения операционки
            switch (m.Msg)
            {
                case WM_DLL_EVENT:
                    AddTextEvent("WM_DLL_EVENT");
                    OnReadCard();
                    AddCodeEvent( 0 );
                    break;
            }
            base.WndProc(ref m);
        }
        /////////////////////////////////////////////////////////////////////////////
        // Небольшая оптимизация
        /////////////////////////////////////////////////////////////////////////////
        void CheckChange()
        {
            Int32 ret = 0;
            Int32 DelayRequest = 0;

            DelayRequest = Convert.ToInt32(nudPeriod.Value);

            // Устанавливает текущий режим
            if ( cbAsync.Checked )
            {
                if( rbSetEvent.Checked )
                {
                    AddTextEvent( "SetModeSelectEvent" );
//                  ret = NRF1996.CRF1996.SetModeSelectEvent(m_hEvent[1], DelayRequest);
                    MessageBox.Show("Временно не реализовано. См. пример C++");
                    AddCodeEvent( ret );
                }
                else
                {
                    AddTextEvent( "SetModeSelectMsg" );
                    ret = NRF1996.CRF1996.SetModeSelectMsg( this.Handle, WM_DLL_EVENT, DelayRequest );
                    AddCodeEvent( ret );
                }
            }
            else
            {
                // Можно использовать любую функцию на выбор
                // Device.SetModeSelectEvent(NULL, m_DelayRequest);
    
                AddTextEvent( "SetModeSelectMsg" );
                ret = NRF1996.CRF1996.SetModeSelectMsg( (System.IntPtr)null, 0, DelayRequest );
                AddCodeEvent( ret );
            }
    
            EnableControls( true );    // FixMe
        }
        /////////////////////////////////////////////////////////////////////////////
        // Включить - выключить асинхронный режим работы
        /////////////////////////////////////////////////////////////////////////////
        private void cbAsync_CheckedChanged(object sender, EventArgs e)
        {
            CheckChange();
        }
        /////////////////////////////////////////////////////////////////////////////
        // Отправлять информацию через SendMessage
        /////////////////////////////////////////////////////////////////////////////
        private void rbCommand_CheckedChanged(object sender, EventArgs e)
        {
            CheckChange();
        }
        /////////////////////////////////////////////////////////////////////////////
        // Отправлять информацию через SetEvent
        /////////////////////////////////////////////////////////////////////////////
        private void rbSetEvent_CheckedChanged(object sender, EventArgs e)
        {
            CheckChange();
        }
        /////////////////////////////////////////////////////////////////////////////
        //
        /////////////////////////////////////////////////////////////////////////////
    }
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
