//---------------------------------------------------------------------------------------------------------------------
#include "stdafx.h"
//---------------------------------------------------------------------------------------------------------------------
CDevice::CDevice()
{
	m_hDevice = NULL;

	Clear();	
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
CDevice::~CDevice()
{
	if(m_hDevice)
	{
		FreeLibrary(m_hDevice);
		m_hDevice = NULL;
	}

	Clear();
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
void CDevice::Clear()
{
	m_OpenDeviceA		= NULL; 
	m_OpenDeviceW		= NULL; 

	m_SearchDevice		= NULL;
	m_CloseDevice		= NULL;
	m_IsDeviceOpen		= NULL;

	m_SetIndicationMode = NULL;
	m_SetDisplayRed		= NULL;
	m_SetDisplayGreen	= NULL;
	m_SetDisplay		= NULL;
	m_SetBeep			= NULL;
	m_GetDeviceInfoA	= NULL;
	m_GetDeviceInfoW	= NULL;

	m_ReadCard			= NULL;
	m_ClearCard			= NULL;

	m_WriteCard			= NULL;
	m_InitCard			= NULL;

	m_GetMaskEvent		= NULL;

	m_SetModeSelectMsg  = NULL;
	m_SetModeSelectEvent= NULL;
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
bool CDevice::LoadDll(TCHAR *str, int sz_str)
{
	bool ret = false;

	str[0] = 0;

	m_hDevice = LoadLibrary(_T("rf1996.dll"));

	if(!m_hDevice)
	{
		wcscpy_s(str, sz_str, _T("  !"));
	}
	else
	{
		pfnInit InitLib		= (pfnInit)GetProcAddress(m_hDevice,  "Init");

		m_OpenDeviceA		= (pfnOpenDeviceA)GetProcAddress(m_hDevice,  "OpenDeviceA");
		m_OpenDeviceW		= (pfnOpenDeviceW)GetProcAddress(m_hDevice,  "OpenDeviceW");

		m_SearchDevice		= (pfnSearchDevice)GetProcAddress(m_hDevice, "SearchDevice");
		m_CloseDevice		= (pfnCloseDevice)GetProcAddress(m_hDevice,  "CloseDevice");
		m_IsDeviceOpen		= (pfnIsDeviceOpen)GetProcAddress(m_hDevice, "IsDeviceOpen");

		m_SetIndicationMode = (pfnSetIndicationMode)GetProcAddress(m_hDevice, "SetIndicationMode");	

		m_SetDisplayRed		= (pfnSetDisplayRed)GetProcAddress(m_hDevice,	"SetDisplayRed");
		m_SetDisplayGreen	= (pfnSetDisplayGreen)GetProcAddress(m_hDevice, "SetDisplayGreen");
		m_SetDisplay		= (pfnSetDisplay)GetProcAddress(m_hDevice,		"SetDisplay");

		m_SetBeep			= (pfnSetBeep)GetProcAddress(m_hDevice,			"SetBeep");

		m_GetDeviceInfoA	= (pfnGetDeviceInfoA)GetProcAddress(m_hDevice,	"GetDeviceInfoA");
		m_GetDeviceInfoW	= (pfnGetDeviceInfoW)GetProcAddress(m_hDevice,	"GetDeviceInfoW");

		m_ReadCard			= (pfnReadCard)GetProcAddress(m_hDevice,		"ReadCard");
		m_ClearCard			= (pfnClearCard)GetProcAddress(m_hDevice,		"ClearCard");
		m_WriteCard			= (pfnWriteCard)GetProcAddress(m_hDevice,		"WriteCard");
		m_InitCard			= (pfnInitCard)GetProcAddress(m_hDevice,		"InitCard");

		m_GetMaskEvent		= (pfnGetMaskEvent)GetProcAddress(m_hDevice,	 "GetMaskEvent");

		m_SetModeSelectMsg  = (pfnSetModeSelectMsg)GetProcAddress(m_hDevice, "SetModeSelectMsg");

		m_SetModeSelectEvent= (pfnSetModeSelectEvent)GetProcAddress(m_hDevice,"SetModeSelectEvent");


		if(
			m_OpenDeviceA		&& 
			m_OpenDeviceW		&& 
			m_SearchDevice		&&
			m_CloseDevice		&&
			m_IsDeviceOpen		&&
			m_SetIndicationMode &&
			m_SetDisplayRed		&&
			m_SetDisplayGreen	&&
			m_SetDisplay		&&
			m_SetBeep			&&
			m_GetDeviceInfoA	&&
			m_GetDeviceInfoW	&&

			m_ReadCard			&&
			m_ClearCard			&&
			m_WriteCard			&&
			m_InitCard			&&

			m_GetMaskEvent		&&
			m_SetModeSelectMsg  &&
			m_SetModeSelectEvent
			)
		{
			if(InitLib)
			{
				if(!InitLib())	//   ,   
					ret = true;
				else
					wcscpy_s(str, sz_str, _T("  dll!"));
			}

			ret = true;
		}
		else
		{
			wcscpy_s(str, sz_str, _T("  !"));
		}
	}
	return ret;
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::OpenDeviceA(char *port)
{
	return m_OpenDeviceA(port);
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::OpenDeviceW(wchar_t *port)
{
	return m_OpenDeviceW(port);
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::SearchDevice()
{
	return m_SearchDevice();
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::CloseDevice()
{
	return m_CloseDevice();
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
BOOL CDevice::IsDeviceOpen()
{
	return m_IsDeviceOpen();
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::SetIndicationMode(DWORD mode)
{
	return m_SetIndicationMode(mode);
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::SetDisplayRed(BOOL fRed)
{
	return m_SetDisplayRed(fRed);
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::SetDisplayGreen(BOOL fGreen)
{
	return m_SetDisplayGreen(fGreen);
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::SetDisplay(BOOL fRed, BOOL fGreen)
{
	return m_SetDisplay(fRed, fGreen);
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::SetBeep(DWORD dwDuration)
{
	return m_SetBeep(dwDuration);
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::GetDeviceInfoA(SDeviceInfoA *DevInfo)
{
	return m_GetDeviceInfoA(DevInfo);
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::GetDeviceInfoW(SDeviceInfoW *DevInfo)
{
	return m_GetDeviceInfoW(DevInfo);
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::ReadCard(SCardInfo* CardInfo)
{
	return m_ReadCard(CardInfo);
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::ClearCard()
{
	return m_ClearCard();
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::WriteCard(DWORD LimitLocks)
{
	return m_WriteCard(LimitLocks);
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::InitCard(BYTE *EmMarineCode)
{
	return m_InitCard(EmMarineCode);
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::GetMaskEvent(DWORD* MaskEvent)
{
	return m_GetMaskEvent(MaskEvent);
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::SetModeSelectMsg(HWND hWnd, UINT Msg, DWORD Delay)
{
	return m_SetModeSelectMsg(hWnd, Msg, Delay);
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
DWORD CDevice::SetModeSelectEvent(HANDLE hEvent, DWORD Delay)
{
	return m_SetModeSelectEvent(hEvent, Delay);
}
//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------



	