/////////////////////////////////////////////////////////////////////////////
// CDevice.h    rf1996.dll
/////////////////////////////////////////////////////////////////////////////
typedef DWORD (*pfnInit)();
typedef DWORD (*pfnOpenDeviceA)(char *port);
typedef DWORD (*pfnOpenDeviceW)(wchar_t *port);
typedef DWORD (*pfnSearchDevice)();
typedef DWORD (*pfnCloseDevice)();
typedef BOOL  (*pfnIsDeviceOpen)();
/////////////////////////////////////////////////////////////////////////////
typedef DWORD (*pfnSetIndicationMode)(DWORD mode);
/////////////////////////////////////////////////////////////////////////////
typedef DWORD (*pfnSetDisplayRed)(BOOL fRed);
typedef DWORD (*pfnSetDisplayGreen)(BOOL fGreen);
typedef DWORD (*pfnSetDisplay)(BOOL fRed, BOOL fGreen);
/////////////////////////////////////////////////////////////////////////////
typedef DWORD (*pfnSetBeep)(DWORD dwDuration);
/////////////////////////////////////////////////////////////////////////////
typedef DWORD (*pfnGetDeviceInfoA)(SDeviceInfoA *DevInfo);
typedef DWORD (*pfnGetDeviceInfoW)(SDeviceInfoW *DevInfo);
/////////////////////////////////////////////////////////////////////////////
typedef DWORD (*pfnReadCard)(SCardInfo* CardInfo);
typedef DWORD (*pfnClearCard)();						
/////////////////////////////////////////////////////////////////////////////
typedef DWORD (*pfnInitCard)(BYTE *EmMarineCode);
typedef DWORD (*pfnWriteCard)(DWORD LimitLocks);
/////////////////////////////////////////////////////////////////////////////
typedef DWORD (*pfnGetMaskEvent)(DWORD* MaskEvent);
/////////////////////////////////////////////////////////////////////////////
typedef DWORD (*pfnSetModeSelectMsg)(HWND hWnd, UINT Msg, DWORD Delay);
typedef DWORD (*pfnSetModeSelectEvent)(HANDLE hEvent, DWORD Delay);
/////////////////////////////////////////////////////////////////////////////
class CDevice
{
	HMODULE					m_hDevice;	

	pfnOpenDeviceA			m_OpenDeviceA; 
	pfnOpenDeviceW			m_OpenDeviceW; 

	pfnSearchDevice			m_SearchDevice;
	pfnCloseDevice			m_CloseDevice;
	pfnIsDeviceOpen			m_IsDeviceOpen;
	pfnSetIndicationMode	m_SetIndicationMode;

	pfnSetDisplayRed		m_SetDisplayRed;
	pfnSetDisplayGreen		m_SetDisplayGreen;
	pfnSetDisplay			m_SetDisplay;

	pfnSetBeep				m_SetBeep;

	pfnGetDeviceInfoA		m_GetDeviceInfoA;
	pfnGetDeviceInfoW		m_GetDeviceInfoW;

	pfnReadCard				m_ReadCard;
	pfnClearCard			m_ClearCard;
	
	pfnWriteCard			m_WriteCard;
	pfnInitCard				m_InitCard;
	
	pfnGetMaskEvent			m_GetMaskEvent;
	
	pfnSetModeSelectMsg		m_SetModeSelectMsg;
	pfnSetModeSelectEvent	m_SetModeSelectEvent;

	void	Clear();

public:
	CDevice();
	~CDevice();

	bool LoadDll(TCHAR *str, int sz_str);

	DWORD OpenDeviceA(char *port);
	DWORD OpenDeviceW(wchar_t *port);
	DWORD SearchDevice();
	DWORD CloseDevice();
	BOOL  IsDeviceOpen();

	DWORD SetIndicationMode(DWORD mode);

	DWORD SetDisplayRed(BOOL fRed);
	DWORD SetDisplayGreen(BOOL fGreen);
	DWORD SetDisplay(BOOL fRed, BOOL fGreen);

	DWORD SetBeep(DWORD dwDuration);

	DWORD GetDeviceInfoA(SDeviceInfoA *DevInfo);
	DWORD GetDeviceInfoW(SDeviceInfoW *DevInfo);

	DWORD ReadCard(SCardInfo* CardInfo);
	DWORD ClearCard();						
	
	DWORD InitCard(BYTE *EmMarineCode);	
	DWORD WriteCard(DWORD LimitLocks);
	
	DWORD GetMaskEvent(DWORD* MaskEvent);
	
	DWORD SetModeSelectMsg(HWND hWnd, UINT Msg, DWORD Delay);
	DWORD SetModeSelectEvent(HANDLE hEvent, DWORD Delay);
};
/////////////////////////////////////////////////////////////////////////////