// CDlgAbout.h : interface of the CDlgAbout class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

class CDlgScanning : public CDialogImpl<CDlgScanning>
{
	HANDLE m_hThread;
public:
	enum { IDD = IDD_SCANNING};
	//==========================================================================================
	//
	//==========================================================================================
	BEGIN_MSG_MAP(CDlgScanning)
		MESSAGE_HANDLER(WM_INITDIALOG,	OnInitDialog)

		COMMAND_ID_HANDLER(IDOK,		OnOKCmd)
		COMMAND_ID_HANDLER(IDCANCEL,	OnCloseCmd)
	END_MSG_MAP()
	//==========================================================================================
	//
	//==========================================================================================
	// Handler prototypes (uncomment arguments if needed):
	//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)
	//==========================================================================================
	//
	//==========================================================================================
	CDlgScanning()
	{
		m_hThread = NULL;
	}
	//==========================================================================================
	//
	//==========================================================================================
	~CDlgScanning()
	{
		if(m_hThread)
		{
			CloseHandle(m_hThread);
			m_hThread = NULL;
		}
	}
	//==========================================================================================
	//
	//==========================================================================================	
	DWORD Run()
	{
		DWORD ret = Device.SearchDevice();

		if(Device.IsDeviceOpen())
			PostMessage(WM_COMMAND, IDOK);
		else
			PostMessage(WM_COMMAND, IDCANCEL);

		return ret;
	}
	//==========================================================================================
	//			 
	//==========================================================================================	
	static DWORD WINAPI Scanning(LPVOID Param)
	{
		CDlgScanning *dlg = reinterpret_cast<CDlgScanning *>(Param);

		return dlg->Run();
	}
	//==========================================================================================
	//
	//==========================================================================================
	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		m_hThread = CreateThread(NULL, 0, Scanning, (LPVOID)this, 0, NULL);

		CenterWindow(GetParent());
		return TRUE;
	}
	//==========================================================================================
	//
	//==========================================================================================
	LRESULT OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		EndDialog(wID);
		return 0;
	}
	//==========================================================================================
	//
	//==========================================================================================
	LRESULT OnOKCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		if(WaitForSingleObject(m_hThread, 1000) != WAIT_OBJECT_0)		
			TerminateThread(m_hThread, 0);
		
		CloseHandle(m_hThread);
		m_hThread = NULL;

		EndDialog(wID);
		return 0;
	}
	//==========================================================================================
	//
	//==========================================================================================

};
/////////////////////////////////////////////////////////////////////////////

