// CDlgAbout.h : interface of the CDlgAbout class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

class CDlgAbout : public CDialogImpl<CDlgAbout>
{
	CStatic m_ExeVersion;
public:
	enum { IDD = IDD_ABOUT};
	//==========================================================================================
	//
	//==========================================================================================
	BEGIN_MSG_MAP(CDlgAbout)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(IDOK, OnCloseCmd)
		COMMAND_ID_HANDLER(IDCANCEL, OnCloseCmd)
	END_MSG_MAP()
	//==========================================================================================
	//
	//==========================================================================================
	// Handler prototypes (uncomment arguments if needed):
	//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)
	//==========================================================================================
	//
	//==========================================================================================
	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		TCHAR FileName[MAX_PATH];
		TCHAR str[32];		
		WORD MajorVersion    = 0; 
		WORD MinorVersion    = 0; 
		WORD BuildNumber     = 0; 
		WORD RevisionNumber  = 0;
		DWORD lpdwHandle     = 0;

		m_ExeVersion = GetDlgItem(IDC_ST_VERSION_EXE);

		m_ExeVersion.SetWindowText(_T("  "));

		DWORD size = GetModuleFileName(NULL, FileName, ARRAYSIZE(FileName));		

		size = GetFileVersionInfoSize(FileName, &lpdwHandle);

		BYTE* versionInfo = new BYTE[size];
		if (GetFileVersionInfo(FileName, lpdwHandle, size, versionInfo))
		{
			DWORD				dwMS; 
			DWORD				dwLS;
			UINT				uiLen ;
			VS_FIXEDFILEINFO*	lpVerInfo;

			if(VerQueryValue(versionInfo, _T("\\"), reinterpret_cast<LPVOID*>(&lpVerInfo), &uiLen))   
			{
				dwMS = lpVerInfo->dwFileVersionMS ;
				dwLS = lpVerInfo->dwFileVersionLS ;

				wsprintf(str, _T("%i.%i.%i.%i"), HIWORD(dwMS), LOWORD(dwMS), HIWORD(dwLS), LOWORD(dwLS));

				m_ExeVersion.SetWindowText(str);
			}		
		}

		delete[] versionInfo;

		CenterWindow(GetParent());
		return TRUE;
	}
	//==========================================================================================
	//
	//==========================================================================================
	LRESULT OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		EndDialog(wID);
		return 0;
	}
	//==========================================================================================
	//
	//==========================================================================================

};
/////////////////////////////////////////////////////////////////////////////

