// Maindlg.h : interface of the CDlgMain class
//
/////////////////////////////////////////////////////////////////////////////
#pragma once
/////////////////////////////////////////////////////////////////////////////
class CDlgMain : public CDialogImpl<CDlgMain>, public CWinDataExchange<CDlgMain>, public CMessageFilter
{
	TCHAR			m_Port[255];		// COM-
	int				m_ConnectMode;		//  
	int				m_DelayRequest;		//   
	int				m_EventMode;		//       
	int				m_SoundMode;		//     
	int				m_DelaySound;		//    

	int				m_LimitLocks;		// Max - ,    

	CListViewCtrl	m_lvDeviceInfo;		//     
	CListViewCtrl	m_lvCardInfo;		//   	
	CListViewCtrl	m_lvListEvent;		//  

	CEditNum		m_enDelayRequest;	//  UpDown
	CUpDownCtrl		m_udDelayRequest;	//

	CEditNum		m_enDelaySound;		//  UpDown
	CUpDownCtrl		m_udDelaySound;		//

	CEditNum		m_enLimitLocks;		//  UpDown
	CUpDownCtrl		m_udLimitLocks;		//

	CEditNum		m_enHiEmMarine;		//  UpDown
	CUpDownCtrl		m_udHiEmMarine;	//

	CEditNum		m_enLowEmMarine;		//  UpDown
	CUpDownCtrl		m_udLowEmMarine;	//


	TCHAR			m_CaptionButtonConnect[255];	//   IDC_BTN_CONNECT
	TCHAR			m_CaptionButtonDisConnect[255];

	int				m_EventCount;		// -   m_lvListEvent

	//    -  Em-Marine
	TCHAR			m_Square[6];		//    

	int				m_HiEmMarine;		//  
	int				m_LowEmMarine;		//  

	//  
	HANDLE			m_hEvent[2];
	HANDLE			m_hThread;

public:
	enum { IDD = IDD_MAIN};
	//==========================================================================================
	//
	//==========================================================================================
	BEGIN_MSG_MAP(CDlgMain)
		MESSAGE_HANDLER(WM_INITDIALOG,			OnInitDialog)	
		MESSAGE_HANDLER(WM_DESTROY,				OnDestroy)

		MESSAGE_HANDLER(WM_DLL_EVENT,			OnDllEvent)

		COMMAND_ID_HANDLER(IDC_RD_PORT,			OnPortClick)
		COMMAND_ID_HANDLER(IDC_RD_SCAN,			OnPortClick)

		COMMAND_ID_HANDLER(IDC_BTN_CONNECT,		OnConnectCmd)
		COMMAND_ID_HANDLER(IDC_BTN_REQUEST,		OnRequestCmd)
		COMMAND_ID_HANDLER(IDC_BTN_SOUND,		OnSoundCmd)		

		COMMAND_ID_HANDLER(IDC_CHK_RED,			OnIndicRedCmd)
		COMMAND_ID_HANDLER(IDC_CHK_GREEN,		OnIndicGreenCmd)

		COMMAND_ID_HANDLER(IDC_CHK_ASYNK,		OnCheckAsyncCmd)
		COMMAND_ID_HANDLER(IDC_RD_COMMAND,		OnCheckAsyncCmd)
		COMMAND_ID_HANDLER(IDC_RD_SET_EVENT,	OnCheckAsyncCmd)

		COMMAND_ID_HANDLER(IDC_RD_SOUND_AUTO,	OnCheckSoundCmd)
		COMMAND_ID_HANDLER(IDC_RD_SOUND_MANUAL,	OnCheckSoundCmd)

		COMMAND_ID_HANDLER(IDC_BTN_SAVE_CARD,	OnSaveCardCmd)
		COMMAND_ID_HANDLER(IDC_BTN_CLEAR_CARD,	OnClearCardCmd)

		COMMAND_ID_HANDLER(IDC_BTN_GIVE_OUT,	OnGiveOutCardCmd)		

		NOTIFY_HANDLER_EX(IDC_UD_PERIOD,	UDN_DELTAPOS, OnDeltaPos)
	END_MSG_MAP()
	//==========================================================================================
	//
	//==========================================================================================
	BEGIN_DDX_MAP(CDlgMain)
		DDX_RADIO(IDC_RD_PORT,				 m_ConnectMode)
		DDX_RADIO(IDC_RD_COMMAND,			 m_EventMode)
		DDX_RADIO(IDC_RD_SOUND_AUTO,		 m_SoundMode)

		DDX_TEXT_LEN(IDC_ED_COM,			 m_Port,		ARRAYSIZE(m_Port))	

		DDX_TEXT_LEN(IDC_ED_SQUARE,			 m_Square,		ARRAYSIZE(m_Square))	

		DDX_INT_RANGE(IDC_ED_HI,			m_HiEmMarine,	  0, 255)
		DDX_INT_RANGE(IDC_ED_LOW,			m_LowEmMarine,    0, 65535)		

		DDX_INT_RANGE(IDC_ED_PERIOD,		 m_DelayRequest,  100, 10000)
		DDX_INT_RANGE(IDC_ED_SOUND_DURATION, m_DelaySound,    100, 10000)

		DDX_INT_RANGE(IDC_ED_MAX_LOCKS,		 m_LimitLocks, 1, 15)
		
	END_DDX_MAP() 
	//==========================================================================================
	//
	//==========================================================================================
	// Handler prototypes (uncomment arguments if needed):
	//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)
	//==========================================================================================
	//
	//==========================================================================================
	CDlgMain()
	{
		m_ConnectMode	= 0;
		m_EventMode		= 0;
		m_SoundMode	    = 0;
		m_DelayRequest  = 500;
		m_DelaySound    = 300;

		m_EventCount	= 0;
		m_LimitLocks	= 1;	

		m_HiEmMarine	= 255;		//  
		m_LowEmMarine	= 65535;	//  

		ZeroMemory(m_CaptionButtonConnect,		sizeof(m_CaptionButtonConnect));
		ZeroMemory(m_CaptionButtonDisConnect,	sizeof(m_CaptionButtonDisConnect));	
		ZeroMemory(m_Square,					sizeof(m_Square));

		wcscpy_s(m_Port,	_T("COM3"));

		wcscpy_s(m_Square,  _T("2B00"));

		for (int i=0; i < 2; i++)
		{
			m_hEvent[i] =  CreateEvent(NULL, TRUE, FALSE, NULL);

			if(!m_hEvent[i])
				MessageBox(_T("  Event"), gCaption, MB_OK | MB_ICONERROR);
		}			
	}
	//==========================================================================================
	//
	//==========================================================================================
	~CDlgMain()
	{
		for (int i=0; i < 2; i++)
		{
			if(!m_hEvent[i])
			{
				CloseHandle(m_hEvent[i]);
				m_hEvent[i] = NULL;
			}
		}

		if(m_hThread)
		{
			CloseHandle(m_hThread);
			m_hThread = NULL;
		}
	}
	//==========================================================================================
	//
	//==========================================================================================	
	DWORD OnEventDlg()
	{
		bool  Flag = true;
		DWORD EventMask;

		while(Flag)
		{
			switch(WaitForMultipleObjects(2, m_hEvent, FALSE, INFINITE))
			{
			case WAIT_OBJECT_0:		//  	
				Flag = false;
				break;

			case WAIT_OBJECT_0 + 1:
				ResetEvent(m_hEvent[1]);
				AddTextEvent(_T(" Event"));				

				Device.GetMaskEvent(&EventMask);

				AddCodeEvent(EventMask);

				if(EventMask & ME_CARD_CHANGE)
				{
					SCardInfo	CardInfo;
					DWORD		ret;

					OutputDebugString(_T(" Event:  \r\n"));

					if(EventMask & ME_CARD_ON_ADAPTER)
					{	//   
						AddTextEvent(_T("ReadCard"));

						ret = Device.ReadCard(&CardInfo);

						AddCodeEvent(ret);
					}
					else
					{	
						ret = rf_NO_CARD;	//  					
					}

					if(!ret)
						PrintCard(CardInfo);	//   
					else
						PrintErrorCard(ret);
				}	

				if(EventMask & ME_CONNECTION_DEVICE)
				{
					OutputDebugString(_T(" Event:    \r\n"));

					Device.CloseDevice();
				}
				break;

			case WAIT_TIMEOUT:
				OutputDebugString(_T("WAIT_TIMEOUT\r\n"));
				break;

			case WAIT_FAILED:
				OutputDebugString(_T("WAIT_FAILED\r\n"));
				Flag = false;
				break;
			}
		}
		
		OutputDebugString(_T("Flag = false\r\n"));
		return 0;
	}
	//==========================================================================================
	//		  OnEventDlg
	//==========================================================================================	
	static DWORD WINAPI OnEvent(LPVOID Param)
	{
		CDlgMain *dlg = reinterpret_cast<CDlgMain *>(Param);

		return dlg->OnEventDlg();
	}
	//=================================================================================
	//
	//=================================================================================	
	BOOL PreTranslateMessage(MSG* pMsg) 
	{ 
		return IsDialogMessage(pMsg); 
	}
	//==========================================================================================
	//
	//==========================================================================================
	void InitAddStaticCardInfo()
	{
		DWORD ExStyle = m_lvCardInfo.GetExtendedListViewStyle();	
		m_lvCardInfo.SetExtendedListViewStyle(ExStyle | LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);		

		m_lvCardInfo.InsertColumn(0, _T(""),	LVCFMT_LEFT, 200);
		m_lvCardInfo.InsertColumn(1, _T(""),	LVCFMT_LEFT, 180);
	}
	//==========================================================================================
	//
	//==========================================================================================
	void InitAddStaticDeviceInfo()
	{
		DWORD ExStyle = m_lvDeviceInfo.GetExtendedListViewStyle();	
		m_lvDeviceInfo.SetExtendedListViewStyle(ExStyle | LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);		

		m_lvDeviceInfo.InsertColumn(0, _T(""),	LVCFMT_LEFT, 200);
		m_lvDeviceInfo.InsertColumn(1, _T(""),	LVCFMT_LEFT, 180);
	}
	//==========================================================================================
	//
	//==========================================================================================
	void InitAddStaticListEvent()
	{
		DWORD ExStyle = m_lvListEvent.GetExtendedListViewStyle();	
		m_lvListEvent.SetExtendedListViewStyle(ExStyle | LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);		

		m_lvListEvent.InsertColumn(0, _T(""),	LVCFMT_LEFT, 210);
		m_lvListEvent.InsertColumn(1, _T(""),	LVCFMT_LEFT, 70);
	}
	//==========================================================================================
	//
	//==========================================================================================
	void AddCardParam()
	{
		m_lvCardInfo.InsertItem(0, _T(" "));
		m_lvCardInfo.InsertItem(1, _T(" Temic"));
		m_lvCardInfo.InsertItem(2, _T(" Em-Marine"));
		m_lvCardInfo.InsertItem(3, _T("Max - "));
		m_lvCardInfo.InsertItem(4, _T("- "));
		m_lvCardInfo.InsertItem(5, _T(" "));
		m_lvCardInfo.InsertItem(6, _T(" "));
	}
	//==========================================================================================
	//
	//==========================================================================================
	void AddDeviceParam()
	{
		m_lvDeviceInfo.InsertItem(0, _T(""));
		m_lvDeviceInfo.InsertItem(1, _T(""));
		m_lvDeviceInfo.InsertItem(2, _T(" "));
		m_lvDeviceInfo.InsertItem(3, _T(""));
		m_lvDeviceInfo.InsertItem(4, _T("FirmWare"));
		m_lvDeviceInfo.InsertItem(5, _T(""));
		m_lvDeviceInfo.InsertItem(6, _T("- "));
	}
	//==========================================================================================
	//       
	//==========================================================================================
	void AddTextEvent(TCHAR *str)
	{
		m_lvListEvent.InsertItem(m_EventCount, str);
	}
	//==========================================================================================
	void AddCodeEvent(int Code)
	{
		TCHAR str[32];

		_ltow_s(Code, str, 10);
		m_lvListEvent.SetItemText(m_EventCount++, 1, str);
	}
	//==========================================================================================
	//
	//==========================================================================================
	void IncEvent()
	{
		m_EventCount++;
	}
	//==========================================================================================
	//		   
	//==========================================================================================
	void PrintDeviceInfo()
	{
		SDeviceInfoW data;
		TCHAR		 str[255];

		Device.GetDeviceInfoW(&data);

		m_lvDeviceInfo.SetItemText(0, 1, data.Port);		//  COM-

		m_lvDeviceInfo.SetItemText(1, 1, data.DeviceName);	//  

		wsprintf(str, _T("%i"), data.SerialNumber);
		m_lvDeviceInfo.SetItemText(2, 1, str);				//   

		wsprintf(str, _T("%i"), data.ModelNumber);
		m_lvDeviceInfo.SetItemText(3, 1, str);				// 

		wsprintf(str, _T("%i"), data.FirmwareVersion);
		m_lvDeviceInfo.SetItemText(4, 1, str);				// Firmware

		//   
		switch(data.LicenseStatus)
		{
		case els_no_info:	wcscpy_s(str, _T(" "));			break;
		
		case els_none:		wcscpy_s(str, _T("  "));break;
		case els_conclude:	wcscpy_s(str, _T(" "));		break;
		case els_hard_error:wcscpy_s(str, _T(" "));			break;

		case els_ok:		
			wsprintf(str, _T("  %02i.%02i.%04i"), 
					data.LicenseDay,
					data.LicenseMonth,
					data.LicenseYear					
			);			
			break;

		default:			wcscpy_s(str, _T(" "));		break;
		}

		m_lvDeviceInfo.SetItemText(5, 1, str);

		//     
		if(els_ok == data.LicenseStatus)		
			wsprintf(str, L"%i", data.CountCard);
		else
			str[0] = 0;
		
		m_lvDeviceInfo.SetItemText(6, 1, str);		
	}	
	//==========================================================================================
	//		     
	//==========================================================================================
	void PrintCard(SCardInfo& CardInfo)
	{		
		TCHAR		str[128];
		TCHAR*		p = NULL;	

		//  ,   -   

		switch(CardInfo.CardType)
		{			
		case ect_clean_temic:	p = _T(" ");				break;
		case ect_temic:			p = _T("  ");			break;
		case ect_bad_password:	p = _T(" ");			break;
		case esi_em_marine:		p = _T("Em-Marine");				break;
		default:				p = _T(" ");		break;
		}

		// 
		m_lvCardInfo.SetItemText(0, 1, p);	

		//  
		if(CardInfo.Flags & FCI_TEMIC)
			GetTemicCode(CardInfo.TemicCode, str, ARRAYSIZE(str));
		else
			str[0] = 0;

		m_lvCardInfo.SetItemText(1, 1, str);	

		//  Em-Marine 
		if(CardInfo.Flags & FCI_EM_MARINE)
			GetEmMarineCode(CardInfo.EmMarineCode, str, ARRAYSIZE(str));
		else
			str[0] = 0;

		m_lvCardInfo.SetItemText(2, 1, str);

		//  
		if(CardInfo.Flags & FCI_LIMIT_LOCKS)
			_ultow_s(CardInfo.LimitLocks, str, ARRAYSIZE(str), 10);
		else
			str[0] = 0;

		m_lvCardInfo.SetItemText(3, 1, str);

		// - 
		if(CardInfo.Flags & FCI_LOCK_INFO)
			_ultow_s(CardInfo.CountBorrow, str, ARRAYSIZE(str), 10);
		else
			str[0] = 0;

		m_lvCardInfo.SetItemText(4, 1, str);


		//  
		if(CardInfo.Flags & FCI_LOCK_INFO)
			_ultow_s(CardInfo.NumLastLocks, str, ARRAYSIZE(str), 10);
		else
			str[0] = 0;

		m_lvCardInfo.SetItemText(5, 1, str);

		//  
		str[0] = 0;
		if(CardInfo.Flags & FCI_LOCK_INFO)
		{
			if(CardInfo.BatteryCondition)
				wcscpy_s(str, _T(""));
			else
				wcscpy_s(str, _T(""));

		}
		m_lvCardInfo.SetItemText(6, 1, str);		
	}
	//==========================================================================================
	//		    
	//==========================================================================================
	void PrintErrorCard(DWORD ret)
	{
		TCHAR		str[128];
		TCHAR*		p = NULL;	

		str[0] = 0;
		m_lvCardInfo.SetItemText(1, 1, str);
		m_lvCardInfo.SetItemText(2, 1, str);
		m_lvCardInfo.SetItemText(3, 1, str);
		m_lvCardInfo.SetItemText(4, 1, str);
		m_lvCardInfo.SetItemText(5, 1, str);
		m_lvCardInfo.SetItemText(6, 1, str);

		switch(ret)
		{
		case rf_NO_CARD:		p = _T("   ");	break;	
		case rf_EEPROM_ERROR:	p = _T("  ");			break;
		case rf_DATA_ERROR:		p = _T("  ");		break;
		default:				p = _T(" ");		break;
		}

		m_lvCardInfo.SetItemText(0, 1, p);	
	}
	//==========================================================================================
	//		- 
	//==========================================================================================
	void EnableControls(BOOL fPortOpen)
	{
		BOOL Flag;

		GetDlgItem(IDC_BTN_REQUEST).EnableWindow(fPortOpen);
		GetDlgItem(IDC_CHK_ASYNK).EnableWindow(fPortOpen);

		GetDlgItem(IDC_RD_SOUND_AUTO).EnableWindow(fPortOpen);
		GetDlgItem(IDC_RD_SOUND_MANUAL).EnableWindow(fPortOpen);
		GetDlgItem(IDC_ED_MAX_LOCKS).EnableWindow(fPortOpen);
		GetDlgItem(IDC_BTN_SAVE_CARD).EnableWindow(fPortOpen);
		GetDlgItem(IDC_BTN_CLEAR_CARD).EnableWindow(fPortOpen);

		GetDlgItem(IDC_ED_SQUARE).EnableWindow(fPortOpen);
		GetDlgItem(IDC_ED_HI).EnableWindow(fPortOpen);
		GetDlgItem(IDC_ED_LOW).EnableWindow(fPortOpen);

		GetDlgItem(IDC_BTN_GIVE_OUT).EnableWindow(fPortOpen);

		m_udLimitLocks.EnableWindow(fPortOpen);
		m_udHiEmMarine.EnableWindow(fPortOpen);
		m_udLowEmMarine.EnableWindow(fPortOpen);

		//   		
		BOOL fAsyncMode;

		if(IsDlgButtonChecked(IDC_CHK_ASYNK))
			fAsyncMode = TRUE;
		else
			fAsyncMode = FALSE;

		if(fPortOpen && fAsyncMode)
			Flag = TRUE;
		else
			Flag = FALSE;

		GetDlgItem(IDC_ST_PERIOD).EnableWindow(Flag);
		GetDlgItem(IDC_ED_PERIOD).EnableWindow(Flag);
		GetDlgItem(IDC_ST_MS).EnableWindow(Flag);
		GetDlgItem(IDC_ST_EVENT).EnableWindow(Flag);
		GetDlgItem(IDC_RD_COMMAND).EnableWindow(Flag);
		GetDlgItem(IDC_RD_SET_EVENT).EnableWindow(Flag);		

		m_udDelayRequest.EnableWindow(Flag);

		//  
		if(fPortOpen && m_SoundMode)
			Flag = TRUE;
		else
			Flag = FALSE;

		GetDlgItem(IDC_CHK_RED).EnableWindow(Flag);
		GetDlgItem(IDC_CHK_GREEN).EnableWindow(Flag);
		GetDlgItem(IDC_ST_ON_SOUND).EnableWindow(Flag);
		GetDlgItem(IDC_ED_SOUND_DURATION).EnableWindow(Flag);
		GetDlgItem(IDC_ST_MS_SOUND).EnableWindow(Flag);
		GetDlgItem(IDC_BTN_SOUND).EnableWindow(Flag);	

		m_udDelaySound.EnableWindow(Flag);	
	}
	//==========================================================================================
	//			( WM_USER + 1 )
	//==========================================================================================
	LRESULT OnDllEvent(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
	{		
		SCardInfo* ci        = reinterpret_cast<SCardInfo*>(lParam);
		DWORD      EventMask = (DWORD)wParam;

		AddTextEvent(_T("WM_DLL_EVENT"));
		AddCodeEvent(EventMask);

		if(EventMask & ME_CARD_ON_ADAPTER)
			PrintCard(*ci);				//   
		else
			PrintErrorCard(rf_NO_CARD);	//  
		
		return 0;
	}
	//==========================================================================================
	//
	//==========================================================================================
	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		m_lvCardInfo = GetDlgItem(IDC_LIST_CARD_INFO);
		InitAddStaticCardInfo();

		m_lvDeviceInfo = GetDlgItem(IDC_LIST_DEVICE);
		InitAddStaticDeviceInfo();	

		m_lvListEvent  = GetDlgItem(IDC_LIST_EVENT);
		InitAddStaticListEvent();

		AddCardParam();
		AddDeviceParam();

		//  - ,    
		m_enLimitLocks   = GetDlgItem(IDC_ED_MAX_LOCKS);
		m_udLimitLocks	 = m_enLimitLocks.CreateUpDownControl(m_hWnd, 
										IDC_UD_MAX_LOCKS, 
										15, 
										0, 
										m_LimitLocks);


		//  
		m_enDelayRequest = GetDlgItem(IDC_ED_PERIOD);
		m_udDelayRequest = m_enDelayRequest.CreateUpDownControl(m_hWnd, 
										IDC_UD_PERIOD, 
										10000, 
										100, 
										m_DelayRequest);

		//  
		m_enDelaySound = GetDlgItem(IDC_ED_SOUND_DURATION);
		m_udDelaySound = m_enDelaySound.CreateUpDownControl(m_hWnd, 
										IDC_UD_DURATION_SOUND, 
										10000, 
										100, 
										m_DelaySound);

		// Em-Marine Hi
		m_enHiEmMarine = GetDlgItem(IDC_ED_HI);	// IDC_ED_LOW m_LowEmMarine

		m_udHiEmMarine= m_enHiEmMarine.CreateUpDownControl(m_hWnd, 
										IDC_UD_HI, 
										255, 
										0, 
										m_HiEmMarine);

		// Em-Marine Lo
		m_enLowEmMarine = GetDlgItem(IDC_ED_LOW);	// IDC_ED_LOW m_LowEmMarine

		m_udLowEmMarine= m_enLowEmMarine.CreateUpDownControl(m_hWnd, 
										IDC_UD_LOW, 
										65535, 
										0, 
										m_LowEmMarine);		

		EnableControls(FALSE);

		DoDataExchange(FALSE);

		//  
		GetDlgItem(IDC_BTN_CONNECT).GetWindowText(m_CaptionButtonConnect, ARRAYSIZE(m_CaptionButtonConnect));
		wcscpy_s(m_CaptionButtonDisConnect, _T(""));

		//  Thread
		m_hThread = CreateThread(NULL, 0, OnEvent, (LPVOID)this, 0, NULL);

		// 
		
		_Module.GetMessageLoop()->AddMessageFilter(this);

//		CenterWindow(GetParent());
		return TRUE;
	}
	//=================================================================================
	//
	//=================================================================================	
	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
	{	
		SetEvent(m_hEvent[0]);

		if(WaitForSingleObject(m_hThread, 1000) != WAIT_OBJECT_0)
		{
			TerminateThread(m_hThread, 0);

			OutputDebugString(_T("OnDestroy TerminateThread\r\n"));
		}
		else
		{
			OutputDebugString(_T("OnDestroy OK\r\n"));
		}

		// 
		_Module.GetMessageLoop()->RemoveMessageFilter(this);
		return 1;
	}
	
	//==========================================================================================
	//				 ""
	//==========================================================================================
	LRESULT  OnConnectCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		DWORD ret = -1;

		if(Device.IsDeviceOpen())
		{
			AddTextEvent(_T("CloseDevice"));			

			ret = Device.CloseDevice();

			AddCodeEvent(ret);

			//   
			GetDlgItem(IDC_BTN_CONNECT).SetWindowText(m_CaptionButtonConnect);

			//   
			EnableControls(FALSE);
		}
		else
		{
			DoDataExchange(TRUE);	//  

			if(!m_ConnectMode)
			{	//     
				AddTextEvent(_T("OpenDeviceW"));			

				ret = Device.OpenDeviceW(m_Port);

				AddCodeEvent(ret);
			}
			else
			{	//     Thread
				CDlgScanning dlg;

				dlg.DoModal();				
			}

			//   
			if(Device.IsDeviceOpen())
			{
				PrintDeviceInfo();		//    	

				//   
				GetDlgItem(IDC_BTN_CONNECT).SetWindowText(m_CaptionButtonDisConnect);

				//   
				EnableControls(TRUE);
			}
		}
		return 0;
	}	
	//==========================================================================================
	//				Temic  
	//==========================================================================================
	void GetTemicCode(BYTE* Code, TCHAR *str, int sz_str)
	{
		int Len = 0;

		for( int i=0; i < 8; i++)		
			Len += wsprintf(str + Len, _T("%02x "), Code[i]);		
	}
	//==========================================================================================
	//				Em-Marine  
	//==========================================================================================
	void GetEmMarineCode(BYTE* Code, TCHAR *str, int sz_str)
	{
		u_short *SquareBrackets = reinterpret_cast<u_short*>(&(Code[3]));
		u_short *Decimal		= reinterpret_cast<u_short*>(&(Code[0]));

		wsprintf(str, _T("[%04X] %i, %i"), *SquareBrackets, Code[2], *Decimal);
	}	
	//==========================================================================================
	//				 "   "
	//==========================================================================================
	LRESULT  OnRequestCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		SCardInfo CardInfo;
		DWORD     ret;

		AddTextEvent(_T("ReadCard"));

		ret = Device.ReadCard(&CardInfo);

		AddCodeEvent(ret);

		if(!ret)
			PrintCard(CardInfo);	//   
		else
			PrintErrorCard(ret);

		return 0;
	}	
	//==========================================================================================
	//			   
	//==========================================================================================	
	LRESULT OnClearCardCmd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		DWORD ret;

		AddTextEvent(_T("ClearCard"));

		ret = Device.ClearCard();			

		AddCodeEvent(ret);	

		return 0;
	}
	//==========================================================================================
	//			 
	//==========================================================================================	
	LRESULT OnSaveCardCmd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		BYTE	EmMarineCode[5];
		u_short *SquareBrackets = reinterpret_cast<u_short*>(&(EmMarineCode[3]));
		u_short *Decimal		= reinterpret_cast<u_short*>(&(EmMarineCode[0]));
		DWORD	ret;		
		wchar_t *endptr;

		DoDataExchange(TRUE);

		ZeroMemory(EmMarineCode, ARRAYSIZE(EmMarineCode));

		EmMarineCode[2] = BYTE(m_HiEmMarine);
		*Decimal        = u_short(m_LowEmMarine); 

		*SquareBrackets = u_short(wcstol(m_Square, &endptr, 16));

		AddTextEvent(_T("InitCard"));

		ret = Device.InitCard(EmMarineCode);

		AddCodeEvent(ret);	
		
		return 0;
	}	
	//==========================================================================================
	//			 
	//==========================================================================================	
	LRESULT OnGiveOutCardCmd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		DWORD ret;

		DoDataExchange(TRUE);		//  - , 
									//     

		AddTextEvent(_T("WriteCard"));

		ret = Device.WriteCard(m_LimitLocks);			

		AddCodeEvent(ret);	

		return 0;
	}
	//==========================================================================================
	//			-     
	//==========================================================================================	
	LRESULT OnCheckAsyncCmd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		DWORD ret;

		DoDataExchange(TRUE);							//  	

		//   
		if(IsDlgButtonChecked(IDC_CHK_ASYNK))
		{
			if(m_EventMode)
			{
				AddTextEvent(_T("SetModeSelectEvent"));

				ret = Device.SetModeSelectEvent(m_hEvent[1], m_DelayRequest);			

				AddCodeEvent(ret);						
			}
			else
			{
				AddTextEvent(_T("SetModeSelectMsg"));

				ret = Device.SetModeSelectMsg(m_hWnd, WM_DLL_EVENT, m_DelayRequest);			

				AddCodeEvent(ret);				
			}
		}
		else
		{
			//      
//			Device.SetModeSelectEvent(NULL, m_DelayRequest);

			AddTextEvent(_T("SetModeSelectMsg"));

			ret = Device.SetModeSelectMsg(NULL, 0, m_DelayRequest);			

			AddCodeEvent(ret);
		}

		EnableControls(TRUE);	// FixMe

		return 0;
	}
	//==========================================================================================
	//			-      
	//==========================================================================================	
	LRESULT OnCheckSoundCmd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		DWORD ret;

		DoDataExchange(TRUE);							//  

		//    
		AddTextEvent(_T("SetIndicationMode"));

		ret = Device.SetIndicationMode(m_SoundMode);	//   

		AddCodeEvent(ret);

		if((!ret) && m_SoundMode)
		{	//   

			//  
			BOOL m_Red, m_Green;

			if(BST_CHECKED == IsDlgButtonChecked(IDC_CHK_RED))
				m_Red = TRUE;
			else
				m_Red = FALSE;

			if(BST_CHECKED == IsDlgButtonChecked(IDC_CHK_GREEN))
				m_Green = TRUE;
			else
				m_Green = FALSE;

			AddTextEvent(_T("SetDisplay"));

			ret = Device.SetDisplay(m_Red, m_Green);

			AddCodeEvent(ret);
		}		

		EnableControls(TRUE);	//  -    
		return 0;	
	}
	//==========================================================================================
	//			    
	//==========================================================================================	
	LRESULT OnSoundCmd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		DWORD	ret;

		DoDataExchange(TRUE);	//  -

		AddTextEvent(_T("SetBeep"));

		ret = Device.SetBeep(m_DelaySound);

		AddCodeEvent(ret);	
		
		return 0;
	}
	//==========================================================================================
	//			-  
	//==========================================================================================	
	LRESULT OnIndicRedCmd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		BOOL	Flag;
		DWORD	ret;

		if(BST_CHECKED == IsDlgButtonChecked(IDC_CHK_RED))
			Flag = TRUE;
		else
			Flag = FALSE;

		AddTextEvent(_T("SetDisplayRed"));

		ret = Device.SetDisplayRed(Flag);

		AddCodeEvent(ret);

		return 0;
	}
	//==========================================================================================
	//			-  
	//==========================================================================================	
	LRESULT OnIndicGreenCmd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		BOOL	Flag;
		DWORD	ret;

		if(BST_CHECKED == IsDlgButtonChecked(IDC_CHK_GREEN))
			Flag = TRUE;
		else
			Flag = FALSE;

		AddTextEvent(_T("SetDisplayGreen"));

		ret = Device.SetDisplayGreen(Flag);

		AddCodeEvent(ret);

		return 0;
	}
	//==========================================================================================
	//		 UpDown
	//==========================================================================================
	LRESULT OnDeltaPos(LPNMHDR pnmh)
	{		
		NM_UPDOWN* ptr = (NM_UPDOWN*)pnmh;

		ptr->iDelta *= 100;

		return 0;
	}	
	//==========================================================================================
	//
	//==========================================================================================
	LRESULT OnPortClick(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		BOOL Flag;

		if(IsDlgButtonChecked(IDC_RD_PORT))
			Flag = TRUE;
		else
			Flag = FALSE;

		GetDlgItem(IDC_ED_COM).EnableWindow(Flag);

		return 0;
	}	
	//==========================================================================================
	//
	//==========================================================================================
};
/////////////////////////////////////////////////////////////////////////////

