class CMainWindow : public CFrameWindowImpl<CMainWindow, CWindow, CFrameWinTraits>,
	public CMessageFilter, public CIdleHandler
{	
	CDlgMain*			m_DlgMain;		

public:
	DECLARE_FRAME_WND_CLASS(NULL, IDR_MAINFRAME);
	//==========================================================================================
	// 
	//==========================================================================================	
	BEGIN_MSG_MAP(CMainWindow)
		MSG_WM_GETMINMAXINFO(OnGetMinMaxInfo)

		MESSAGE_HANDLER(WM_CREATE,					OnCreate)
		MESSAGE_HANDLER(WM_DESTROY,					OnDestroy)	

		COMMAND_ID_HANDLER(ID_FILE_EXIT,			OnFileExitCmd)
		COMMAND_ID_HANDLER(ID_HELP_ABOUT,			OnHelpAboutCmd)		

		CHAIN_MSG_MAP(CFrameWindowImpl<CMainWindow>)
	END_MSG_MAP()
	//==========================================================================================
	// 
	//==========================================================================================	
	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		m_DlgMain = new CDlgMain();

		m_hWndClient = m_DlgMain->Create(m_hWnd);
		m_DlgMain->ShowWindow(SW_SHOW);

		// 
		RECT rc, rcClient, rcMain;

		m_DlgMain->GetWindowRect(&rc);
		GetClientRect(&rcClient);
		GetWindowRect(&rcMain);

		int dx = (rc.right  - rc.left) - (rcClient.right  - rcClient.left);
		int dy = (rc.bottom - rc.top)  - (rcClient.bottom - rcClient.top);

		SetWindowPos(NULL, 0, 0, rcMain.right  - rcMain.left + dx, 
								 rcMain.bottom - rcMain.top  + dy, 
								 SWP_NOZORDER | SWP_NOMOVE);
			

		// register object for message filtering and idle updates
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		ATLASSERT(pLoop != NULL);
		pLoop->AddMessageFilter(this);
		pLoop->AddIdleHandler(this);

		return 0;
	}
	//==========================================================================================
	// 
	//==========================================================================================
	LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		Device.CloseDevice();

		// unregister message filtering and idle updates
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		ATLASSERT(pLoop != NULL);
		pLoop->RemoveMessageFilter(this);
		pLoop->RemoveIdleHandler(this);

		PostQuitMessage(0);
		return 0;
	}
	//==========================================================================================
	// 
	//==========================================================================================
	virtual BOOL OnIdle()
	{
//		UIUpdateToolBar();
		return FALSE;
	}	
	//==========================================================================================
	// 
	//==========================================================================================
	virtual BOOL PreTranslateMessage(MSG* pMsg)
	{
		pMsg;
		return FALSE;
	}	
	//==========================================================================================
	//					   
	//==========================================================================================	
	void OnGetMinMaxInfo(LPMINMAXINFO mmi)
	{
		mmi->ptMinTrackSize.x = 775;	// FixMe
		mmi->ptMinTrackSize.y = 630;	

		mmi->ptMaxTrackSize.x = 775;	// 
		mmi->ptMaxTrackSize.y = 630;
	}
	//==========================================================================================
	// 
	//==========================================================================================
	LRESULT OnFileExitCmd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		PostMessage(WM_CLOSE);
		return 0;
	}
	//==========================================================================================
	// 
	//==========================================================================================
	LRESULT OnHelpAboutCmd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		CDlgAbout dlg;

		dlg.DoModal();

		return 0;
	}
	//==========================================================================================
	// 
	//==========================================================================================
	

};