//----------------------------------------------------------------------------------------------------
//    rf1998.dll
//     4 
//    0      .
//----------------------------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------------------------
#define EXPORT extern "C" __declspec (dllexport)
//----------------------------------------------------------------------------------------------------
//    
//----------------------------------------------------------------------------------------------------
EXPORT DWORD Init();
EXPORT DWORD OpenDeviceA(char *port);
EXPORT DWORD OpenDeviceW(wchar_t *port);
EXPORT DWORD SearchDevice();
EXPORT DWORD CloseDevice();
EXPORT BOOL  IsDeviceOpen();
//----------------------------------------------------------------------------------------------------
//      :
//	0 - 
//  1 - 
//----------------------------------------------------------------------------------------------------
EXPORT DWORD SetIndicationMode(DWORD mode);
//----------------------------------------------------------------------------------------------------
// - , 
//       ,  - 
// 0     - ,
//  - 
//----------------------------------------------------------------------------------------------------
EXPORT DWORD SetDisplayRed(BOOL fRed);
EXPORT DWORD SetDisplayGreen(BOOL fGreen);
EXPORT DWORD SetDisplay(BOOL fRed, BOOL fGreen);
//----------------------------------------------------------------------------------------------------
//    dwDuration  (10 - 2550 .), 
//       ,  - 
//----------------------------------------------------------------------------------------------------
EXPORT DWORD SetBeep(DWORD dwDuration);
//----------------------------------------------------------------------------------------------------
//	   
//----------------------------------------------------------------------------------------------------
enum ELicenseStatus : UINT
{
	els_no_info		= 0,	//  
	els_ok			= 0xAA,	//  
	els_none		= 0xFE,	//   
	els_conclude	= 0xFD,	//  
	els_hard_error	= 0xFC,	//  
};
//----------------------------------------------------------------------------------------------------
//       
//----------------------------------------------------------------------------------------------------
struct SDeviceInfoA
{
	char			Port[16];				// Com- 
	char			DeviceName[128];		//  	
	DWORD			SerialNumber;			//   
	DWORD			ModelNumber;			//  
	DWORD			FirmwareVersion;		//  Firmware		
	ELicenseStatus  LicenseStatus;			//    
	DWORD			LicenseYear;			// 
	DWORD			LicenseMonth;			// 	
	DWORD			LicenseDay;				//   
	DWORD			CountCard;				// - ,   -  
};
//----------------------------------------------------------------------------------------------------
struct SDeviceInfoW
{
	wchar_t			Port[16];				// Com- 
	wchar_t			DeviceName[128];		//  
	DWORD			SerialNumber;			//   
	DWORD			ModelNumber;			//  
	DWORD			FirmwareVersion;		//  Firmware		
	ELicenseStatus  LicenseStatus;			//    
	DWORD			LicenseYear;			// 
	DWORD			LicenseMonth;			// 	
	DWORD			LicenseDay;				//   
	DWORD			CountCard;				// - ,   -  
};
//----------------------------------------------------------------------------------------------------
EXPORT DWORD GetDeviceInfoA(SDeviceInfoA *DevInfo);
EXPORT DWORD GetDeviceInfoW(SDeviceInfoW *DevInfo);
//----------------------------------------------------------------------------------------------------
//   
//----------------------------------------------------------------------------------------------------
enum ECardType : UINT
{
	ect_none		 = 0,			//    

	ect_clean_temic	 = 0x10,		//   (  )

	ect_temic		 = 0x20,		//   ( )

	ect_bad_password = 0x30,		// " " (  )

	esi_em_marine	 = 0x40,		// Em-Marine (21  2012)

	//   
	ect_EEPROM_error = 0x80,		//   
	ect_data_error	 = 0x81,		//    -  

	ect_unknow		 = 0xF0,		//  		
};
//----------------------------------------------------------------------------------------------------
struct SCardInfo
{
	DWORD		Flags;				//      (. )
	ECardType	CardType;			//  
	BYTE		TemicCode[8];		//  Temic 
	BYTE		EmMarineCode[8];	//  Em-Marine
	DWORD		LimitLocks;			//  - ,     

	DWORD		CountBorrow;		// -  
	DWORD		NumLastLocks;		//    
	BOOL		BatteryCondition;	//  : TRUE - , FALSE -  
};
//----------------------------------------------------------------------------------------------------
//      SCardInfo
// .  FCI_LOCK_INFO  : CountBorrow, NumLastLocks, BatteryCondition
//----------------------------------------------------------------------------------------------------
#define FCI_TEMIC			1
#define FCI_EM_MARINE		2
#define FCI_LIMIT_LOCKS		4
#define FCI_LOCK_INFO		8
//----------------------------------------------------------------------------------------------------
EXPORT DWORD ReadCard(SCardInfo* CardInfo);		//    
EXPORT DWORD ClearCard();						//    
//----------------------------------------------------------------------------------------------------
//     Em-Mrine   .
//----------------------------------------------------------------------------------------------------
EXPORT DWORD InitCard(BYTE *EmMarineCode);
//----------------------------------------------------------------------------------------------------
//    .      InitCard
//----------------------------------------------------------------------------------------------------
EXPORT DWORD WriteCard(DWORD LimitLocks);
//----------------------------------------------------------------------------------------------------
//   .
//----------------------------------------------------------------------------------------------------
EXPORT DWORD GetMaskEvent(DWORD* MaskEvent);
//
// MaskEvent     : 
//
#define ME_CARD_CHANGE			1	// 1 -    
#define ME_CARD_ON_ADAPTER		2	// 2 -    , 0 - 
#define ME_CONNECTION_DEVICE	4	// 4 -    
//----------------------------------------------------------------------------------------------------
//       
//----------------------------------------------------------------------------------------------------
EXPORT DWORD SetModeSelectMsg(HWND hWnd, UINT Msg, DWORD Delay);
EXPORT DWORD SetModeSelectEvent(HANDLE hEvent, DWORD Delay);
//----------------------------------------------------------------------------------------------------
//	 
//----------------------------------------------------------------------------------------------------
enum EErrorCode : INT
{
	rf_SUCCESS				=	0,	//   
	rf_INVALID_PARAM		=   -1,	//  	
	rf_OPEN_NOT_EXIST		=	-2,	//   
	rf_OPEN_ACCESS			=   -3, //    
	rf_NOT_USB				=   -4, //   USB 
	rf_OPEN_PORT			=   -5, //    
	rf_UNKNOWN_DEVICE		=   -6,	//  
	rf_DEVICE_NOT_FOUND		=	-7, //   
	rf_ALREADY_OPEN			=	-8,	//    (   )

	rf_EEPROM_ERROR			=   -9,	//    
	rf_DATA_ERROR			=  -10,	//    -  
	rf_DEVICE_NOT_CONNECT	=  -11,	//    
	rf_NO_CARD				=  -12,	//    	
	rf_DLL_NOT_INIT			=  -14,	//   
	rf_NO_ANSWER_FOR_CMD	=  -15,	//    
	rf_DISPLAY_MODE_ERROR	=  -16,	//       
	rf_UNKNOWN_ERROR		=  -17,	//  

	rf_ERROR_LICENSE_HARD	=  -20,	//   
	rf_LICENSE_FINISHED		=  -21,	//  
	rf_LICENSE_NOT_VALID	=  -22, //  

	rf_CARD_NOT_FOUND		=  -30,	//   
	rf_BAD_PASSWORD			=  -31,	//  
	rf_ERROR_SAVE_CARD		=  -32,	//   
};
//----------------------------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------------------------
